// A Bison parser, made by GNU Bison 3.7.4.

// Skeleton implementation for Bison LALR(1) parsers in C++

// Copyright (C) 2002-2015, 2018-2020 Free Software Foundation, Inc.

// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

// As a special exception, you may create a larger work that contains
// part or all of the Bison parser skeleton and distribute that work
// under terms of your choice, so long as that work isn't itself a
// parser generator using the skeleton or a modified version thereof
// as a parser skeleton.  Alternatively, if you modify or redistribute
// the parser skeleton itself, you may (at your option) remove this
// special exception, which will cause the skeleton and the resulting
// Bison output files to be licensed under the GNU General Public
// License without this special exception.

// This special exception was added by the Free Software Foundation in
// version 2.2 of Bison.

// DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
// especially those whose name start with YY_ or yy_.  They are
// private implementation details that can be changed or removed.



// First part of user prologue.
#line 1 "parse/thrifty.yy"

/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements. See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership. The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License. You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied. See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */

/**
 * Thrift parser.
 *
 * This parser is used on a thrift definition file.
 *
 */

#define __STDC_LIMIT_MACROS
#define __STDC_FORMAT_MACROS

#include <cassert>
#include <stdio.h>
#include <inttypes.h>
#include <limits.h>
#include <stack>
#include <utility>

#include <boost/optional.hpp>

#include <thrift/compiler/ast/base_types.h>
#include <thrift/compiler/ast/t_scope.h>
#include <thrift/compiler/ast/t_union.h>
#include <thrift/compiler/parse/parsing_driver.h>
#include <thrift/compiler/ast/t_container.h>

/**
 * Note macro expansion because this is different between OSS and internal
 * build, sigh.
 */
#include THRIFTY_HH

/**
 * Declare fbthrift_compiler_parse_lex() so we can use it.
 */
YY_DECL;
#define yylex fbthrift_compiler_parse_lex

namespace apache {
namespace thrift {
namespace compiler {
namespace {

/**
 * This global variable is used for automatic numbering of field indices etc.
 * when parsing the members of a struct. Field values are automatically
 * assigned starting from -1 and working their way down.
 */
int y_field_val = -1;

int g_arglist = 0;

// Assume ownership of a pointer.
template <typename T>
std::unique_ptr<T> own(T* ptr) {
  return std::unique_ptr<T>(ptr);
}

// Return the value being pointed to as a temporary and deletes the given pointer.
template<typename T>
T consume(T* ptr) {
  assert(ptr != nullptr);
  T result(std::move(*ptr));
  delete ptr;
  return result;
}

} // namespace
} // namespace compiler
} // namespace thrift
} // namespace apache


#line 134 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"


#include "thrifty.hh"




#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> // FIXME: INFRINGES ON USER NAME SPACE.
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif


// Whether we are compiled with exception support.
#ifndef YY_EXCEPTIONS
# if defined __GNUC__ && !defined __EXCEPTIONS
#  define YY_EXCEPTIONS 0
# else
#  define YY_EXCEPTIONS 1
# endif
#endif



// Enable debugging if requested.
#if YYDEBUG

// A pseudo ostream that takes yydebug_ into account.
# define YYCDEBUG if (yydebug_) (*yycdebug_)

# define YY_SYMBOL_PRINT(Title, Symbol)         \
  do {                                          \
    if (yydebug_)                               \
    {                                           \
      *yycdebug_ << Title << ' ';               \
      yy_print_ (*yycdebug_, Symbol);           \
      *yycdebug_ << '\n';                       \
    }                                           \
  } while (false)

# define YY_REDUCE_PRINT(Rule)          \
  do {                                  \
    if (yydebug_)                       \
      yy_reduce_print_ (Rule);          \
  } while (false)

# define YY_STACK_PRINT()               \
  do {                                  \
    if (yydebug_)                       \
      yy_stack_print_ ();                \
  } while (false)

#else // !YYDEBUG

# define YYCDEBUG if (false) std::cerr
# define YY_SYMBOL_PRINT(Title, Symbol)  YYUSE (Symbol)
# define YY_REDUCE_PRINT(Rule)           static_cast<void> (0)
# define YY_STACK_PRINT()                static_cast<void> (0)

#endif // !YYDEBUG

#define yyerrok         (yyerrstatus_ = 0)
#define yyclearin       (yyla.clear ())

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYRECOVERING()  (!!yyerrstatus_)

#line 112 "parse/thrifty.yy"
namespace apache { namespace thrift { namespace compiler { namespace yy {
#line 213 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"

  /// Build a parser object.
  parser::parser (apache::thrift::compiler::parsing_driver& driver_yyarg, yyscan_t raw_scanner_yyarg)
#if YYDEBUG
    : yydebug_ (false),
      yycdebug_ (&std::cerr),
#else
    :
#endif
      driver (driver_yyarg),
      raw_scanner (raw_scanner_yyarg)
  {}

  parser::~parser ()
  {}

  parser::syntax_error::~syntax_error () YY_NOEXCEPT YY_NOTHROW
  {}

  /*---------------.
  | symbol kinds.  |
  `---------------*/



  // by_state.
  parser::by_state::by_state () YY_NOEXCEPT
    : state (empty_state)
  {}

  parser::by_state::by_state (const by_state& that) YY_NOEXCEPT
    : state (that.state)
  {}

  void
  parser::by_state::clear () YY_NOEXCEPT
  {
    state = empty_state;
  }

  void
  parser::by_state::move (by_state& that)
  {
    state = that.state;
    that.clear ();
  }

  parser::by_state::by_state (state_type s) YY_NOEXCEPT
    : state (s)
  {}

  parser::symbol_kind_type
  parser::by_state::kind () const YY_NOEXCEPT
  {
    if (state == empty_state)
      return symbol_kind::S_YYEMPTY;
    else
      return YY_CAST (symbol_kind_type, yystos_[+state]);
  }

  parser::stack_symbol_type::stack_symbol_type ()
  {}

  parser::stack_symbol_type::stack_symbol_type (YY_RVREF (stack_symbol_type) that)
    : super_type (YY_MOVE (that.state))
  {
    switch (that.kind ())
    {
      case symbol_kind::S_CommaOrSemicolonOptional: // CommaOrSemicolonOptional
        value.YY_MOVE_OR_COPY< bool > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_tok_dub_constant: // tok_dub_constant
        value.YY_MOVE_OR_COPY< double > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_tok_bool_constant: // tok_bool_constant
      case symbol_kind::S_tok_int_constant: // tok_int_constant
        value.YY_MOVE_OR_COPY< int64_t > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_tok_identifier: // tok_identifier
      case symbol_kind::S_tok_literal: // tok_literal
      case symbol_kind::S_tok_st_identifier: // tok_st_identifier
      case symbol_kind::S_Identifier: // Identifier
      case symbol_kind::S_IntOrLiteral: // IntOrLiteral
        value.YY_MOVE_OR_COPY< std::string > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_TypeAnnotation: // TypeAnnotation
        value.YY_MOVE_OR_COPY< t_annotation* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_TypeAnnotations: // TypeAnnotations
      case symbol_kind::S_TypeAnnotationList: // TypeAnnotationList
      case symbol_kind::S_FunctionAnnotations: // FunctionAnnotations
        value.YY_MOVE_OR_COPY< t_annotations* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_Const: // Const
      case symbol_kind::S_StructuredAnnotation: // StructuredAnnotation
        value.YY_MOVE_OR_COPY< t_const* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_ConstValue: // ConstValue
      case symbol_kind::S_ConstList: // ConstList
      case symbol_kind::S_ConstListContents: // ConstListContents
      case symbol_kind::S_ConstMap: // ConstMap
      case symbol_kind::S_ConstMapContents: // ConstMapContents
      case symbol_kind::S_ConstStruct: // ConstStruct
      case symbol_kind::S_ConstStructContents: // ConstStructContents
      case symbol_kind::S_FieldValue: // FieldValue
        value.YY_MOVE_OR_COPY< t_const_value* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_ContainerType: // ContainerType
      case symbol_kind::S_MapType: // MapType
      case symbol_kind::S_SetType: // SetType
      case symbol_kind::S_ListType: // ListType
        value.YY_MOVE_OR_COPY< t_container* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_DefinitionAttrs: // DefinitionAttrs
        value.YY_MOVE_OR_COPY< t_def_attrs* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_tok_doctext: // tok_doctext
      case symbol_kind::S_CaptureDocText: // CaptureDocText
        value.YY_MOVE_OR_COPY< t_doc > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_Enum: // Enum
      case symbol_kind::S_EnumDefList: // EnumDefList
        value.YY_MOVE_OR_COPY< t_enum* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_EnumDef: // EnumDef
      case symbol_kind::S_EnumValue: // EnumValue
        value.YY_MOVE_OR_COPY< t_enum_value* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_ErrorBlame: // ErrorBlame
        value.YY_MOVE_OR_COPY< t_error_blame > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_ErrorKind: // ErrorKind
        value.YY_MOVE_OR_COPY< t_error_kind > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_ErrorSafety: // ErrorSafety
        value.YY_MOVE_OR_COPY< t_error_safety > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_Exception: // Exception
        value.YY_MOVE_OR_COPY< t_exception* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_Param: // Param
      case symbol_kind::S_Field: // Field
        value.YY_MOVE_OR_COPY< t_field* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_FieldRequiredness: // FieldRequiredness
        value.YY_MOVE_OR_COPY< t_field::e_req > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_FieldIdentifier: // FieldIdentifier
        value.YY_MOVE_OR_COPY< t_field_id > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_FieldList: // FieldList
        value.YY_MOVE_OR_COPY< t_field_list* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_Function: // Function
        value.YY_MOVE_OR_COPY< t_function* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_FunctionList: // FunctionList
        value.YY_MOVE_OR_COPY< t_function_list* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_FunctionQualifier: // FunctionQualifier
        value.YY_MOVE_OR_COPY< t_function_qualifier > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_Interaction: // Interaction
        value.YY_MOVE_OR_COPY< t_interaction* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_ParamList: // ParamList
      case symbol_kind::S_EmptyParamList: // EmptyParamList
        value.YY_MOVE_OR_COPY< t_paramlist* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_BaseType: // BaseType
        value.YY_MOVE_OR_COPY< t_ref<t_base_type> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_Definition: // Definition
        value.YY_MOVE_OR_COPY< t_ref<t_node> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_Extends: // Extends
        value.YY_MOVE_OR_COPY< t_ref<t_service> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_Service: // Service
        value.YY_MOVE_OR_COPY< t_service* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_ResponseAndSinkReturnType: // ResponseAndSinkReturnType
      case symbol_kind::S_SinkReturnType: // SinkReturnType
        value.YY_MOVE_OR_COPY< t_sink* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_ResponseAndStreamReturnType: // ResponseAndStreamReturnType
      case symbol_kind::S_StreamReturnType: // StreamReturnType
        value.YY_MOVE_OR_COPY< t_stream_response* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_Struct: // Struct
        value.YY_MOVE_OR_COPY< t_struct* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_StructuredAnnotations: // StructuredAnnotations
      case symbol_kind::S_NonEmptyStructuredAnnotationList: // NonEmptyStructuredAnnotationList
        value.YY_MOVE_OR_COPY< t_struct_annotations* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_Throws: // Throws
      case symbol_kind::S_MaybeThrows: // MaybeThrows
        value.YY_MOVE_OR_COPY< t_throws* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_ConstStructType: // ConstStructType
      case symbol_kind::S_FunctionType: // FunctionType
      case symbol_kind::S_FieldType: // FieldType
        value.YY_MOVE_OR_COPY< t_type_ref* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_Typedef: // Typedef
        value.YY_MOVE_OR_COPY< t_typedef* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_SinkFieldType: // SinkFieldType
        value.YY_MOVE_OR_COPY< t_typethrowspair > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_Union: // Union
        value.YY_MOVE_OR_COPY< t_union* > (YY_MOVE (that.value));
        break;

      default:
        break;
    }

#if 201103L <= YY_CPLUSPLUS
    // that is emptied.
    that.state = empty_state;
#endif
  }

  parser::stack_symbol_type::stack_symbol_type (state_type s, YY_MOVE_REF (symbol_type) that)
    : super_type (s)
  {
    switch (that.kind ())
    {
      case symbol_kind::S_CommaOrSemicolonOptional: // CommaOrSemicolonOptional
        value.move< bool > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_tok_dub_constant: // tok_dub_constant
        value.move< double > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_tok_bool_constant: // tok_bool_constant
      case symbol_kind::S_tok_int_constant: // tok_int_constant
        value.move< int64_t > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_tok_identifier: // tok_identifier
      case symbol_kind::S_tok_literal: // tok_literal
      case symbol_kind::S_tok_st_identifier: // tok_st_identifier
      case symbol_kind::S_Identifier: // Identifier
      case symbol_kind::S_IntOrLiteral: // IntOrLiteral
        value.move< std::string > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_TypeAnnotation: // TypeAnnotation
        value.move< t_annotation* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_TypeAnnotations: // TypeAnnotations
      case symbol_kind::S_TypeAnnotationList: // TypeAnnotationList
      case symbol_kind::S_FunctionAnnotations: // FunctionAnnotations
        value.move< t_annotations* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_Const: // Const
      case symbol_kind::S_StructuredAnnotation: // StructuredAnnotation
        value.move< t_const* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_ConstValue: // ConstValue
      case symbol_kind::S_ConstList: // ConstList
      case symbol_kind::S_ConstListContents: // ConstListContents
      case symbol_kind::S_ConstMap: // ConstMap
      case symbol_kind::S_ConstMapContents: // ConstMapContents
      case symbol_kind::S_ConstStruct: // ConstStruct
      case symbol_kind::S_ConstStructContents: // ConstStructContents
      case symbol_kind::S_FieldValue: // FieldValue
        value.move< t_const_value* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_ContainerType: // ContainerType
      case symbol_kind::S_MapType: // MapType
      case symbol_kind::S_SetType: // SetType
      case symbol_kind::S_ListType: // ListType
        value.move< t_container* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_DefinitionAttrs: // DefinitionAttrs
        value.move< t_def_attrs* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_tok_doctext: // tok_doctext
      case symbol_kind::S_CaptureDocText: // CaptureDocText
        value.move< t_doc > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_Enum: // Enum
      case symbol_kind::S_EnumDefList: // EnumDefList
        value.move< t_enum* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_EnumDef: // EnumDef
      case symbol_kind::S_EnumValue: // EnumValue
        value.move< t_enum_value* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_ErrorBlame: // ErrorBlame
        value.move< t_error_blame > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_ErrorKind: // ErrorKind
        value.move< t_error_kind > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_ErrorSafety: // ErrorSafety
        value.move< t_error_safety > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_Exception: // Exception
        value.move< t_exception* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_Param: // Param
      case symbol_kind::S_Field: // Field
        value.move< t_field* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_FieldRequiredness: // FieldRequiredness
        value.move< t_field::e_req > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_FieldIdentifier: // FieldIdentifier
        value.move< t_field_id > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_FieldList: // FieldList
        value.move< t_field_list* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_Function: // Function
        value.move< t_function* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_FunctionList: // FunctionList
        value.move< t_function_list* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_FunctionQualifier: // FunctionQualifier
        value.move< t_function_qualifier > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_Interaction: // Interaction
        value.move< t_interaction* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_ParamList: // ParamList
      case symbol_kind::S_EmptyParamList: // EmptyParamList
        value.move< t_paramlist* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_BaseType: // BaseType
        value.move< t_ref<t_base_type> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_Definition: // Definition
        value.move< t_ref<t_node> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_Extends: // Extends
        value.move< t_ref<t_service> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_Service: // Service
        value.move< t_service* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_ResponseAndSinkReturnType: // ResponseAndSinkReturnType
      case symbol_kind::S_SinkReturnType: // SinkReturnType
        value.move< t_sink* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_ResponseAndStreamReturnType: // ResponseAndStreamReturnType
      case symbol_kind::S_StreamReturnType: // StreamReturnType
        value.move< t_stream_response* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_Struct: // Struct
        value.move< t_struct* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_StructuredAnnotations: // StructuredAnnotations
      case symbol_kind::S_NonEmptyStructuredAnnotationList: // NonEmptyStructuredAnnotationList
        value.move< t_struct_annotations* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_Throws: // Throws
      case symbol_kind::S_MaybeThrows: // MaybeThrows
        value.move< t_throws* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_ConstStructType: // ConstStructType
      case symbol_kind::S_FunctionType: // FunctionType
      case symbol_kind::S_FieldType: // FieldType
        value.move< t_type_ref* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_Typedef: // Typedef
        value.move< t_typedef* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_SinkFieldType: // SinkFieldType
        value.move< t_typethrowspair > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_Union: // Union
        value.move< t_union* > (YY_MOVE (that.value));
        break;

      default:
        break;
    }

    // that is emptied.
    that.kind_ = symbol_kind::S_YYEMPTY;
  }

#if YY_CPLUSPLUS < 201103L
  parser::stack_symbol_type&
  parser::stack_symbol_type::operator= (const stack_symbol_type& that)
  {
    state = that.state;
    switch (that.kind ())
    {
      case symbol_kind::S_CommaOrSemicolonOptional: // CommaOrSemicolonOptional
        value.copy< bool > (that.value);
        break;

      case symbol_kind::S_tok_dub_constant: // tok_dub_constant
        value.copy< double > (that.value);
        break;

      case symbol_kind::S_tok_bool_constant: // tok_bool_constant
      case symbol_kind::S_tok_int_constant: // tok_int_constant
        value.copy< int64_t > (that.value);
        break;

      case symbol_kind::S_tok_identifier: // tok_identifier
      case symbol_kind::S_tok_literal: // tok_literal
      case symbol_kind::S_tok_st_identifier: // tok_st_identifier
      case symbol_kind::S_Identifier: // Identifier
      case symbol_kind::S_IntOrLiteral: // IntOrLiteral
        value.copy< std::string > (that.value);
        break;

      case symbol_kind::S_TypeAnnotation: // TypeAnnotation
        value.copy< t_annotation* > (that.value);
        break;

      case symbol_kind::S_TypeAnnotations: // TypeAnnotations
      case symbol_kind::S_TypeAnnotationList: // TypeAnnotationList
      case symbol_kind::S_FunctionAnnotations: // FunctionAnnotations
        value.copy< t_annotations* > (that.value);
        break;

      case symbol_kind::S_Const: // Const
      case symbol_kind::S_StructuredAnnotation: // StructuredAnnotation
        value.copy< t_const* > (that.value);
        break;

      case symbol_kind::S_ConstValue: // ConstValue
      case symbol_kind::S_ConstList: // ConstList
      case symbol_kind::S_ConstListContents: // ConstListContents
      case symbol_kind::S_ConstMap: // ConstMap
      case symbol_kind::S_ConstMapContents: // ConstMapContents
      case symbol_kind::S_ConstStruct: // ConstStruct
      case symbol_kind::S_ConstStructContents: // ConstStructContents
      case symbol_kind::S_FieldValue: // FieldValue
        value.copy< t_const_value* > (that.value);
        break;

      case symbol_kind::S_ContainerType: // ContainerType
      case symbol_kind::S_MapType: // MapType
      case symbol_kind::S_SetType: // SetType
      case symbol_kind::S_ListType: // ListType
        value.copy< t_container* > (that.value);
        break;

      case symbol_kind::S_DefinitionAttrs: // DefinitionAttrs
        value.copy< t_def_attrs* > (that.value);
        break;

      case symbol_kind::S_tok_doctext: // tok_doctext
      case symbol_kind::S_CaptureDocText: // CaptureDocText
        value.copy< t_doc > (that.value);
        break;

      case symbol_kind::S_Enum: // Enum
      case symbol_kind::S_EnumDefList: // EnumDefList
        value.copy< t_enum* > (that.value);
        break;

      case symbol_kind::S_EnumDef: // EnumDef
      case symbol_kind::S_EnumValue: // EnumValue
        value.copy< t_enum_value* > (that.value);
        break;

      case symbol_kind::S_ErrorBlame: // ErrorBlame
        value.copy< t_error_blame > (that.value);
        break;

      case symbol_kind::S_ErrorKind: // ErrorKind
        value.copy< t_error_kind > (that.value);
        break;

      case symbol_kind::S_ErrorSafety: // ErrorSafety
        value.copy< t_error_safety > (that.value);
        break;

      case symbol_kind::S_Exception: // Exception
        value.copy< t_exception* > (that.value);
        break;

      case symbol_kind::S_Param: // Param
      case symbol_kind::S_Field: // Field
        value.copy< t_field* > (that.value);
        break;

      case symbol_kind::S_FieldRequiredness: // FieldRequiredness
        value.copy< t_field::e_req > (that.value);
        break;

      case symbol_kind::S_FieldIdentifier: // FieldIdentifier
        value.copy< t_field_id > (that.value);
        break;

      case symbol_kind::S_FieldList: // FieldList
        value.copy< t_field_list* > (that.value);
        break;

      case symbol_kind::S_Function: // Function
        value.copy< t_function* > (that.value);
        break;

      case symbol_kind::S_FunctionList: // FunctionList
        value.copy< t_function_list* > (that.value);
        break;

      case symbol_kind::S_FunctionQualifier: // FunctionQualifier
        value.copy< t_function_qualifier > (that.value);
        break;

      case symbol_kind::S_Interaction: // Interaction
        value.copy< t_interaction* > (that.value);
        break;

      case symbol_kind::S_ParamList: // ParamList
      case symbol_kind::S_EmptyParamList: // EmptyParamList
        value.copy< t_paramlist* > (that.value);
        break;

      case symbol_kind::S_BaseType: // BaseType
        value.copy< t_ref<t_base_type> > (that.value);
        break;

      case symbol_kind::S_Definition: // Definition
        value.copy< t_ref<t_node> > (that.value);
        break;

      case symbol_kind::S_Extends: // Extends
        value.copy< t_ref<t_service> > (that.value);
        break;

      case symbol_kind::S_Service: // Service
        value.copy< t_service* > (that.value);
        break;

      case symbol_kind::S_ResponseAndSinkReturnType: // ResponseAndSinkReturnType
      case symbol_kind::S_SinkReturnType: // SinkReturnType
        value.copy< t_sink* > (that.value);
        break;

      case symbol_kind::S_ResponseAndStreamReturnType: // ResponseAndStreamReturnType
      case symbol_kind::S_StreamReturnType: // StreamReturnType
        value.copy< t_stream_response* > (that.value);
        break;

      case symbol_kind::S_Struct: // Struct
        value.copy< t_struct* > (that.value);
        break;

      case symbol_kind::S_StructuredAnnotations: // StructuredAnnotations
      case symbol_kind::S_NonEmptyStructuredAnnotationList: // NonEmptyStructuredAnnotationList
        value.copy< t_struct_annotations* > (that.value);
        break;

      case symbol_kind::S_Throws: // Throws
      case symbol_kind::S_MaybeThrows: // MaybeThrows
        value.copy< t_throws* > (that.value);
        break;

      case symbol_kind::S_ConstStructType: // ConstStructType
      case symbol_kind::S_FunctionType: // FunctionType
      case symbol_kind::S_FieldType: // FieldType
        value.copy< t_type_ref* > (that.value);
        break;

      case symbol_kind::S_Typedef: // Typedef
        value.copy< t_typedef* > (that.value);
        break;

      case symbol_kind::S_SinkFieldType: // SinkFieldType
        value.copy< t_typethrowspair > (that.value);
        break;

      case symbol_kind::S_Union: // Union
        value.copy< t_union* > (that.value);
        break;

      default:
        break;
    }

    return *this;
  }

  parser::stack_symbol_type&
  parser::stack_symbol_type::operator= (stack_symbol_type& that)
  {
    state = that.state;
    switch (that.kind ())
    {
      case symbol_kind::S_CommaOrSemicolonOptional: // CommaOrSemicolonOptional
        value.move< bool > (that.value);
        break;

      case symbol_kind::S_tok_dub_constant: // tok_dub_constant
        value.move< double > (that.value);
        break;

      case symbol_kind::S_tok_bool_constant: // tok_bool_constant
      case symbol_kind::S_tok_int_constant: // tok_int_constant
        value.move< int64_t > (that.value);
        break;

      case symbol_kind::S_tok_identifier: // tok_identifier
      case symbol_kind::S_tok_literal: // tok_literal
      case symbol_kind::S_tok_st_identifier: // tok_st_identifier
      case symbol_kind::S_Identifier: // Identifier
      case symbol_kind::S_IntOrLiteral: // IntOrLiteral
        value.move< std::string > (that.value);
        break;

      case symbol_kind::S_TypeAnnotation: // TypeAnnotation
        value.move< t_annotation* > (that.value);
        break;

      case symbol_kind::S_TypeAnnotations: // TypeAnnotations
      case symbol_kind::S_TypeAnnotationList: // TypeAnnotationList
      case symbol_kind::S_FunctionAnnotations: // FunctionAnnotations
        value.move< t_annotations* > (that.value);
        break;

      case symbol_kind::S_Const: // Const
      case symbol_kind::S_StructuredAnnotation: // StructuredAnnotation
        value.move< t_const* > (that.value);
        break;

      case symbol_kind::S_ConstValue: // ConstValue
      case symbol_kind::S_ConstList: // ConstList
      case symbol_kind::S_ConstListContents: // ConstListContents
      case symbol_kind::S_ConstMap: // ConstMap
      case symbol_kind::S_ConstMapContents: // ConstMapContents
      case symbol_kind::S_ConstStruct: // ConstStruct
      case symbol_kind::S_ConstStructContents: // ConstStructContents
      case symbol_kind::S_FieldValue: // FieldValue
        value.move< t_const_value* > (that.value);
        break;

      case symbol_kind::S_ContainerType: // ContainerType
      case symbol_kind::S_MapType: // MapType
      case symbol_kind::S_SetType: // SetType
      case symbol_kind::S_ListType: // ListType
        value.move< t_container* > (that.value);
        break;

      case symbol_kind::S_DefinitionAttrs: // DefinitionAttrs
        value.move< t_def_attrs* > (that.value);
        break;

      case symbol_kind::S_tok_doctext: // tok_doctext
      case symbol_kind::S_CaptureDocText: // CaptureDocText
        value.move< t_doc > (that.value);
        break;

      case symbol_kind::S_Enum: // Enum
      case symbol_kind::S_EnumDefList: // EnumDefList
        value.move< t_enum* > (that.value);
        break;

      case symbol_kind::S_EnumDef: // EnumDef
      case symbol_kind::S_EnumValue: // EnumValue
        value.move< t_enum_value* > (that.value);
        break;

      case symbol_kind::S_ErrorBlame: // ErrorBlame
        value.move< t_error_blame > (that.value);
        break;

      case symbol_kind::S_ErrorKind: // ErrorKind
        value.move< t_error_kind > (that.value);
        break;

      case symbol_kind::S_ErrorSafety: // ErrorSafety
        value.move< t_error_safety > (that.value);
        break;

      case symbol_kind::S_Exception: // Exception
        value.move< t_exception* > (that.value);
        break;

      case symbol_kind::S_Param: // Param
      case symbol_kind::S_Field: // Field
        value.move< t_field* > (that.value);
        break;

      case symbol_kind::S_FieldRequiredness: // FieldRequiredness
        value.move< t_field::e_req > (that.value);
        break;

      case symbol_kind::S_FieldIdentifier: // FieldIdentifier
        value.move< t_field_id > (that.value);
        break;

      case symbol_kind::S_FieldList: // FieldList
        value.move< t_field_list* > (that.value);
        break;

      case symbol_kind::S_Function: // Function
        value.move< t_function* > (that.value);
        break;

      case symbol_kind::S_FunctionList: // FunctionList
        value.move< t_function_list* > (that.value);
        break;

      case symbol_kind::S_FunctionQualifier: // FunctionQualifier
        value.move< t_function_qualifier > (that.value);
        break;

      case symbol_kind::S_Interaction: // Interaction
        value.move< t_interaction* > (that.value);
        break;

      case symbol_kind::S_ParamList: // ParamList
      case symbol_kind::S_EmptyParamList: // EmptyParamList
        value.move< t_paramlist* > (that.value);
        break;

      case symbol_kind::S_BaseType: // BaseType
        value.move< t_ref<t_base_type> > (that.value);
        break;

      case symbol_kind::S_Definition: // Definition
        value.move< t_ref<t_node> > (that.value);
        break;

      case symbol_kind::S_Extends: // Extends
        value.move< t_ref<t_service> > (that.value);
        break;

      case symbol_kind::S_Service: // Service
        value.move< t_service* > (that.value);
        break;

      case symbol_kind::S_ResponseAndSinkReturnType: // ResponseAndSinkReturnType
      case symbol_kind::S_SinkReturnType: // SinkReturnType
        value.move< t_sink* > (that.value);
        break;

      case symbol_kind::S_ResponseAndStreamReturnType: // ResponseAndStreamReturnType
      case symbol_kind::S_StreamReturnType: // StreamReturnType
        value.move< t_stream_response* > (that.value);
        break;

      case symbol_kind::S_Struct: // Struct
        value.move< t_struct* > (that.value);
        break;

      case symbol_kind::S_StructuredAnnotations: // StructuredAnnotations
      case symbol_kind::S_NonEmptyStructuredAnnotationList: // NonEmptyStructuredAnnotationList
        value.move< t_struct_annotations* > (that.value);
        break;

      case symbol_kind::S_Throws: // Throws
      case symbol_kind::S_MaybeThrows: // MaybeThrows
        value.move< t_throws* > (that.value);
        break;

      case symbol_kind::S_ConstStructType: // ConstStructType
      case symbol_kind::S_FunctionType: // FunctionType
      case symbol_kind::S_FieldType: // FieldType
        value.move< t_type_ref* > (that.value);
        break;

      case symbol_kind::S_Typedef: // Typedef
        value.move< t_typedef* > (that.value);
        break;

      case symbol_kind::S_SinkFieldType: // SinkFieldType
        value.move< t_typethrowspair > (that.value);
        break;

      case symbol_kind::S_Union: // Union
        value.move< t_union* > (that.value);
        break;

      default:
        break;
    }

    // that is emptied.
    that.state = empty_state;
    return *this;
  }
#endif

  template <typename Base>
  void
  parser::yy_destroy_ (const char* yymsg, basic_symbol<Base>& yysym) const
  {
    if (yymsg)
      YY_SYMBOL_PRINT (yymsg, yysym);
  }

#if YYDEBUG
  template <typename Base>
  void
  parser::yy_print_ (std::ostream& yyo, const basic_symbol<Base>& yysym) const
  {
    std::ostream& yyoutput = yyo;
    YYUSE (yyoutput);
    if (yysym.empty ())
      yyo << "empty symbol";
    else
      {
        symbol_kind_type yykind = yysym.kind ();
        yyo << (yykind < YYNTOKENS ? "token" : "nterm")
            << ' ' << yysym.name () << " (";
        YYUSE (yykind);
        yyo << ')';
      }
  }
#endif

  void
  parser::yypush_ (const char* m, YY_MOVE_REF (stack_symbol_type) sym)
  {
    if (m)
      YY_SYMBOL_PRINT (m, sym);
    yystack_.push (YY_MOVE (sym));
  }

  void
  parser::yypush_ (const char* m, state_type s, YY_MOVE_REF (symbol_type) sym)
  {
#if 201103L <= YY_CPLUSPLUS
    yypush_ (m, stack_symbol_type (s, std::move (sym)));
#else
    stack_symbol_type ss (s, sym);
    yypush_ (m, ss);
#endif
  }

  void
  parser::yypop_ (int n)
  {
    yystack_.pop (n);
  }

#if YYDEBUG
  std::ostream&
  parser::debug_stream () const
  {
    return *yycdebug_;
  }

  void
  parser::set_debug_stream (std::ostream& o)
  {
    yycdebug_ = &o;
  }


  parser::debug_level_type
  parser::debug_level () const
  {
    return yydebug_;
  }

  void
  parser::set_debug_level (debug_level_type l)
  {
    yydebug_ = l;
  }
#endif // YYDEBUG

  parser::state_type
  parser::yy_lr_goto_state_ (state_type yystate, int yysym)
  {
    int yyr = yypgoto_[yysym - YYNTOKENS] + yystate;
    if (0 <= yyr && yyr <= yylast_ && yycheck_[yyr] == yystate)
      return yytable_[yyr];
    else
      return yydefgoto_[yysym - YYNTOKENS];
  }

  bool
  parser::yy_pact_value_is_default_ (int yyvalue)
  {
    return yyvalue == yypact_ninf_;
  }

  bool
  parser::yy_table_value_is_error_ (int yyvalue)
  {
    return yyvalue == yytable_ninf_;
  }

  int
  parser::operator() ()
  {
    return parse ();
  }

  int
  parser::parse ()
  {
    int yyn;
    /// Length of the RHS of the rule being reduced.
    int yylen = 0;

    // Error handling.
    int yynerrs_ = 0;
    int yyerrstatus_ = 0;

    /// The lookahead symbol.
    symbol_type yyla;

    /// The return value of parse ().
    int yyresult;

#if YY_EXCEPTIONS
    try
#endif // YY_EXCEPTIONS
      {
    YYCDEBUG << "Starting parse\n";


    /* Initialize the stack.  The initial state will be set in
       yynewstate, since the latter expects the semantical and the
       location values to have been already stored, initialize these
       stacks with a primary value.  */
    yystack_.clear ();
    yypush_ (YY_NULLPTR, 0, YY_MOVE (yyla));

  /*-----------------------------------------------.
  | yynewstate -- push a new symbol on the stack.  |
  `-----------------------------------------------*/
  yynewstate:
    YYCDEBUG << "Entering state " << int (yystack_[0].state) << '\n';
    YY_STACK_PRINT ();

    // Accept?
    if (yystack_[0].state == yyfinal_)
      YYACCEPT;

    goto yybackup;


  /*-----------.
  | yybackup.  |
  `-----------*/
  yybackup:
    // Try to take a decision without lookahead.
    yyn = yypact_[+yystack_[0].state];
    if (yy_pact_value_is_default_ (yyn))
      goto yydefault;

    // Read a lookahead token.
    if (yyla.empty ())
      {
        YYCDEBUG << "Reading a token\n";
#if YY_EXCEPTIONS
        try
#endif // YY_EXCEPTIONS
          {
            symbol_type yylookahead (yylex (driver, raw_scanner));
            yyla.move (yylookahead);
          }
#if YY_EXCEPTIONS
        catch (const syntax_error& yyexc)
          {
            YYCDEBUG << "Caught exception: " << yyexc.what() << '\n';
            error (yyexc);
            goto yyerrlab1;
          }
#endif // YY_EXCEPTIONS
      }
    YY_SYMBOL_PRINT ("Next token is", yyla);

    if (yyla.kind () == symbol_kind::S_YYerror)
    {
      // The scanner already issued an error message, process directly
      // to error recovery.  But do not keep the error token as
      // lookahead, it is too special and may lead us to an endless
      // loop in error recovery. */
      yyla.kind_ = symbol_kind::S_YYUNDEF;
      goto yyerrlab1;
    }

    /* If the proper action on seeing token YYLA.TYPE is to reduce or
       to detect an error, take that action.  */
    yyn += yyla.kind ();
    if (yyn < 0 || yylast_ < yyn || yycheck_[yyn] != yyla.kind ())
      {
        goto yydefault;
      }

    // Reduce or error.
    yyn = yytable_[yyn];
    if (yyn <= 0)
      {
        if (yy_table_value_is_error_ (yyn))
          goto yyerrlab;
        yyn = -yyn;
        goto yyreduce;
      }

    // Count tokens shifted since error; after three, turn off error status.
    if (yyerrstatus_)
      --yyerrstatus_;

    // Shift the lookahead token.
    yypush_ ("Shifting", state_type (yyn), YY_MOVE (yyla));
    goto yynewstate;


  /*-----------------------------------------------------------.
  | yydefault -- do the default action for the current state.  |
  `-----------------------------------------------------------*/
  yydefault:
    yyn = yydefact_[+yystack_[0].state];
    if (yyn == 0)
      goto yyerrlab;
    goto yyreduce;


  /*-----------------------------.
  | yyreduce -- do a reduction.  |
  `-----------------------------*/
  yyreduce:
    yylen = yyr2_[yyn];
    {
      stack_symbol_type yylhs;
      yylhs.state = yy_lr_goto_state_ (yystack_[yylen].state, yyr1_[yyn]);
      /* Variants are always initialized to an empty instance of the
         correct type. The default '$$ = $1' action is NOT applied
         when using variants.  */
      switch (yyr1_[yyn])
    {
      case symbol_kind::S_CommaOrSemicolonOptional: // CommaOrSemicolonOptional
        yylhs.value.emplace< bool > ();
        break;

      case symbol_kind::S_tok_dub_constant: // tok_dub_constant
        yylhs.value.emplace< double > ();
        break;

      case symbol_kind::S_tok_bool_constant: // tok_bool_constant
      case symbol_kind::S_tok_int_constant: // tok_int_constant
        yylhs.value.emplace< int64_t > ();
        break;

      case symbol_kind::S_tok_identifier: // tok_identifier
      case symbol_kind::S_tok_literal: // tok_literal
      case symbol_kind::S_tok_st_identifier: // tok_st_identifier
      case symbol_kind::S_Identifier: // Identifier
      case symbol_kind::S_IntOrLiteral: // IntOrLiteral
        yylhs.value.emplace< std::string > ();
        break;

      case symbol_kind::S_TypeAnnotation: // TypeAnnotation
        yylhs.value.emplace< t_annotation* > ();
        break;

      case symbol_kind::S_TypeAnnotations: // TypeAnnotations
      case symbol_kind::S_TypeAnnotationList: // TypeAnnotationList
      case symbol_kind::S_FunctionAnnotations: // FunctionAnnotations
        yylhs.value.emplace< t_annotations* > ();
        break;

      case symbol_kind::S_Const: // Const
      case symbol_kind::S_StructuredAnnotation: // StructuredAnnotation
        yylhs.value.emplace< t_const* > ();
        break;

      case symbol_kind::S_ConstValue: // ConstValue
      case symbol_kind::S_ConstList: // ConstList
      case symbol_kind::S_ConstListContents: // ConstListContents
      case symbol_kind::S_ConstMap: // ConstMap
      case symbol_kind::S_ConstMapContents: // ConstMapContents
      case symbol_kind::S_ConstStruct: // ConstStruct
      case symbol_kind::S_ConstStructContents: // ConstStructContents
      case symbol_kind::S_FieldValue: // FieldValue
        yylhs.value.emplace< t_const_value* > ();
        break;

      case symbol_kind::S_ContainerType: // ContainerType
      case symbol_kind::S_MapType: // MapType
      case symbol_kind::S_SetType: // SetType
      case symbol_kind::S_ListType: // ListType
        yylhs.value.emplace< t_container* > ();
        break;

      case symbol_kind::S_DefinitionAttrs: // DefinitionAttrs
        yylhs.value.emplace< t_def_attrs* > ();
        break;

      case symbol_kind::S_tok_doctext: // tok_doctext
      case symbol_kind::S_CaptureDocText: // CaptureDocText
        yylhs.value.emplace< t_doc > ();
        break;

      case symbol_kind::S_Enum: // Enum
      case symbol_kind::S_EnumDefList: // EnumDefList
        yylhs.value.emplace< t_enum* > ();
        break;

      case symbol_kind::S_EnumDef: // EnumDef
      case symbol_kind::S_EnumValue: // EnumValue
        yylhs.value.emplace< t_enum_value* > ();
        break;

      case symbol_kind::S_ErrorBlame: // ErrorBlame
        yylhs.value.emplace< t_error_blame > ();
        break;

      case symbol_kind::S_ErrorKind: // ErrorKind
        yylhs.value.emplace< t_error_kind > ();
        break;

      case symbol_kind::S_ErrorSafety: // ErrorSafety
        yylhs.value.emplace< t_error_safety > ();
        break;

      case symbol_kind::S_Exception: // Exception
        yylhs.value.emplace< t_exception* > ();
        break;

      case symbol_kind::S_Param: // Param
      case symbol_kind::S_Field: // Field
        yylhs.value.emplace< t_field* > ();
        break;

      case symbol_kind::S_FieldRequiredness: // FieldRequiredness
        yylhs.value.emplace< t_field::e_req > ();
        break;

      case symbol_kind::S_FieldIdentifier: // FieldIdentifier
        yylhs.value.emplace< t_field_id > ();
        break;

      case symbol_kind::S_FieldList: // FieldList
        yylhs.value.emplace< t_field_list* > ();
        break;

      case symbol_kind::S_Function: // Function
        yylhs.value.emplace< t_function* > ();
        break;

      case symbol_kind::S_FunctionList: // FunctionList
        yylhs.value.emplace< t_function_list* > ();
        break;

      case symbol_kind::S_FunctionQualifier: // FunctionQualifier
        yylhs.value.emplace< t_function_qualifier > ();
        break;

      case symbol_kind::S_Interaction: // Interaction
        yylhs.value.emplace< t_interaction* > ();
        break;

      case symbol_kind::S_ParamList: // ParamList
      case symbol_kind::S_EmptyParamList: // EmptyParamList
        yylhs.value.emplace< t_paramlist* > ();
        break;

      case symbol_kind::S_BaseType: // BaseType
        yylhs.value.emplace< t_ref<t_base_type> > ();
        break;

      case symbol_kind::S_Definition: // Definition
        yylhs.value.emplace< t_ref<t_node> > ();
        break;

      case symbol_kind::S_Extends: // Extends
        yylhs.value.emplace< t_ref<t_service> > ();
        break;

      case symbol_kind::S_Service: // Service
        yylhs.value.emplace< t_service* > ();
        break;

      case symbol_kind::S_ResponseAndSinkReturnType: // ResponseAndSinkReturnType
      case symbol_kind::S_SinkReturnType: // SinkReturnType
        yylhs.value.emplace< t_sink* > ();
        break;

      case symbol_kind::S_ResponseAndStreamReturnType: // ResponseAndStreamReturnType
      case symbol_kind::S_StreamReturnType: // StreamReturnType
        yylhs.value.emplace< t_stream_response* > ();
        break;

      case symbol_kind::S_Struct: // Struct
        yylhs.value.emplace< t_struct* > ();
        break;

      case symbol_kind::S_StructuredAnnotations: // StructuredAnnotations
      case symbol_kind::S_NonEmptyStructuredAnnotationList: // NonEmptyStructuredAnnotationList
        yylhs.value.emplace< t_struct_annotations* > ();
        break;

      case symbol_kind::S_Throws: // Throws
      case symbol_kind::S_MaybeThrows: // MaybeThrows
        yylhs.value.emplace< t_throws* > ();
        break;

      case symbol_kind::S_ConstStructType: // ConstStructType
      case symbol_kind::S_FunctionType: // FunctionType
      case symbol_kind::S_FieldType: // FieldType
        yylhs.value.emplace< t_type_ref* > ();
        break;

      case symbol_kind::S_Typedef: // Typedef
        yylhs.value.emplace< t_typedef* > ();
        break;

      case symbol_kind::S_SinkFieldType: // SinkFieldType
        yylhs.value.emplace< t_typethrowspair > ();
        break;

      case symbol_kind::S_Union: // Union
        yylhs.value.emplace< t_union* > ();
        break;

      default:
        break;
    }



      // Perform the reduction.
      YY_REDUCE_PRINT (yyn);
#if YY_EXCEPTIONS
      try
#endif // YY_EXCEPTIONS
        {
          switch (yyn)
            {
  case 2: // Program: HeaderList DefinitionList
#line 314 "parse/thrifty.yy"
    {
      driver.debug("Program -> Headers DefinitionList");
      /*
      TODO(dreiss): Decide whether full-program doctext is worth the trouble.
      if ($1) {
        driver.program->set_doc($1);
      }
      */
      driver.clear_doctext();
    }
#line 1530 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 3: // Identifier: tok_identifier
#line 327 "parse/thrifty.yy"
    {
      yylhs.value.as < std::string > () = yystack_[0].value.as < std::string > ();
    }
#line 1538 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 4: // Identifier: tok_sink
#line 332 "parse/thrifty.yy"
    {
      yylhs.value.as < std::string > () = "sink";
    }
#line 1546 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 5: // Identifier: tok_oneway
#line 336 "parse/thrifty.yy"
    {
      yylhs.value.as < std::string > () = "oneway";
    }
#line 1554 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 6: // Identifier: tok_readonly
#line 340 "parse/thrifty.yy"
    {
      yylhs.value.as < std::string > () = "readonly";
    }
#line 1562 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 7: // Identifier: tok_idempotent
#line 344 "parse/thrifty.yy"
    {
      yylhs.value.as < std::string > () = "idempotent";
    }
#line 1570 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 8: // Identifier: tok_safe
#line 348 "parse/thrifty.yy"
    {
      yylhs.value.as < std::string > () = "safe";
    }
#line 1578 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 9: // Identifier: tok_transient
#line 352 "parse/thrifty.yy"
    {
      yylhs.value.as < std::string > () = "transient";
    }
#line 1586 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 10: // Identifier: tok_stateful
#line 356 "parse/thrifty.yy"
    {
      yylhs.value.as < std::string > () = "stateful";
    }
#line 1594 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 11: // Identifier: tok_permanent
#line 360 "parse/thrifty.yy"
    {
      yylhs.value.as < std::string > () = "permanent";
    }
#line 1602 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 12: // Identifier: tok_server
#line 364 "parse/thrifty.yy"
    {
      yylhs.value.as < std::string > () = "server";
    }
#line 1610 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 13: // Identifier: tok_client
#line 368 "parse/thrifty.yy"
    {
      yylhs.value.as < std::string > () = "client";
    }
#line 1618 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 14: // CaptureDocText: %empty
#line 374 "parse/thrifty.yy"
    {
      if (driver.mode == parsing_mode::PROGRAM) {
        yylhs.value.as < t_doc > () = driver.doctext;
        driver.doctext = boost::none;
      } else {
        yylhs.value.as < t_doc > () = boost::none;
      }
    }
#line 1631 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 15: // DestroyDocText: %empty
#line 385 "parse/thrifty.yy"
    {
      if (driver.mode == parsing_mode::PROGRAM) {
        driver.clear_doctext();
      }
    }
#line 1641 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 16: // HeaderList: HeaderList DestroyDocText Header
#line 395 "parse/thrifty.yy"
    {
      driver.debug("HeaderList -> HeaderList Header");
    }
#line 1649 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 17: // HeaderList: %empty
#line 399 "parse/thrifty.yy"
    {
      driver.debug("HeaderList -> ");
    }
#line 1657 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 18: // Header: Include
#line 405 "parse/thrifty.yy"
    {
      driver.debug("Header -> Include");
    }
#line 1665 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 19: // Header: tok_namespace Identifier Identifier
#line 409 "parse/thrifty.yy"
    {
      driver.debug("Header -> tok_namespace Identifier Identifier");
      if (driver.mode == parsing_mode::PROGRAM) {
        driver.program->set_namespace(yystack_[1].value.as < std::string > (), yystack_[0].value.as < std::string > ());
      }
    }
#line 1676 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 20: // Header: tok_namespace Identifier tok_literal
#line 416 "parse/thrifty.yy"
    {
      driver.debug("Header -> tok_namespace Identifier tok_literal");
      if (driver.mode == parsing_mode::PROGRAM) {
        driver.program->set_namespace(yystack_[1].value.as < std::string > (), yystack_[0].value.as < std::string > ());
      }
    }
#line 1687 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 21: // Header: tok_cpp_include tok_literal
#line 423 "parse/thrifty.yy"
    {
      driver.debug("Header -> tok_cpp_include tok_literal");
      if (driver.mode == parsing_mode::PROGRAM) {
        driver.program->add_cpp_include(yystack_[0].value.as < std::string > ());
      }
    }
#line 1698 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 22: // Header: tok_hs_include tok_literal
#line 430 "parse/thrifty.yy"
    {
      driver.debug("Header -> tok_hs_include tok_literal");
      // Do nothing. This syntax is handled by the hs compiler
    }
#line 1707 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 23: // Include: tok_include tok_literal
#line 437 "parse/thrifty.yy"
    {
      driver.debug("Include -> tok_include tok_literal");
      if (driver.mode == parsing_mode::INCLUDES) {
        std::string path = driver.include_file(std::string(yystack_[0].value.as < std::string > ()));
        if (!path.empty()) {
          if (driver.program_cache.find(path) == driver.program_cache.end()) {
            auto included_program = driver.program->add_include(path, std::string(yystack_[0].value.as < std::string > ()), driver.scanner->get_lineno());
            driver.program_cache[path] = included_program.get();
            driver.program_bundle->add_program(std::move(included_program));
          } else {
            auto include = std::make_unique<t_include>(driver.program_cache[path]);
            include->set_lineno(driver.scanner->get_lineno());
            driver.program->add_include(std::move(include));
          }
        }
      }
    }
#line 1729 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 24: // DefinitionAttrs: CaptureDocText StructuredAnnotations
#line 457 "parse/thrifty.yy"
    {
      driver.debug("DefinitionAttrs -> CaptureDocText StructuredAnnotations");
      if (yystack_[1].value.as < t_doc > () || yystack_[0].value.as < t_struct_annotations* > () != nullptr) {
        yylhs.value.as < t_def_attrs* > () = new t_def_attrs{std::move(yystack_[1].value.as < t_doc > ()), own(yystack_[0].value.as < t_struct_annotations* > ())};
      } else {
        yylhs.value.as < t_def_attrs* > () = nullptr;
      }
    }
#line 1742 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 25: // DefinitionList: DefinitionList Definition
#line 468 "parse/thrifty.yy"
    {
      driver.debug("DefinitionList -> DefinitionList Definition");
    }
#line 1750 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 26: // DefinitionList: %empty
#line 472 "parse/thrifty.yy"
    {
      driver.debug("DefinitionList -> ");
    }
#line 1758 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 27: // Definition: Const
#line 478 "parse/thrifty.yy"
    {
      driver.debug("Definition -> Const");
      yylhs.value.as < t_ref<t_node> > () = driver.add_def(own(yystack_[0].value.as < t_const* > ()));
    }
#line 1767 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 28: // Definition: Typedef
#line 483 "parse/thrifty.yy"
    {
      driver.debug("Definition -> Typedef");
      yylhs.value.as < t_ref<t_node> > () = driver.add_def(own(yystack_[0].value.as < t_typedef* > ()));
    }
#line 1776 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 29: // Definition: Enum
#line 488 "parse/thrifty.yy"
    {
      driver.debug("Definition -> Enum");
      yylhs.value.as < t_ref<t_node> > () = driver.add_def(own(yystack_[0].value.as < t_enum* > ()));
    }
#line 1785 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 30: // Definition: Struct
#line 493 "parse/thrifty.yy"
    {
      driver.debug("Definition -> Struct");
      yylhs.value.as < t_ref<t_node> > () = driver.add_def(own(yystack_[0].value.as < t_struct* > ()));
    }
#line 1794 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 31: // Definition: Union
#line 498 "parse/thrifty.yy"
    {
      driver.debug("Definition -> Union");
      yylhs.value.as < t_ref<t_node> > () = driver.add_def(own(yystack_[0].value.as < t_union* > ()));
    }
#line 1803 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 32: // Definition: Exception
#line 503 "parse/thrifty.yy"
    {
      driver.debug("Definition -> Exception");
      yylhs.value.as < t_ref<t_node> > () = driver.add_def(own(yystack_[0].value.as < t_exception* > ()));
    }
#line 1812 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 33: // Definition: Service
#line 508 "parse/thrifty.yy"
    {
      driver.debug("Definition -> Service");
      yylhs.value.as < t_ref<t_node> > () = driver.add_def(own(yystack_[0].value.as < t_service* > ()));
    }
#line 1821 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 34: // Definition: Interaction
#line 513 "parse/thrifty.yy"
    {
      driver.debug("Definition -> Interaction");
      yylhs.value.as < t_ref<t_node> > () = driver.add_def(own(yystack_[0].value.as < t_interaction* > ()));
    }
#line 1830 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 35: // $@1: %empty
#line 520 "parse/thrifty.yy"
    {
      driver.start_node(LineType::Typedef);
    }
#line 1838 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 36: // Typedef: DefinitionAttrs tok_typedef FieldType Identifier $@1 TypeAnnotations
#line 524 "parse/thrifty.yy"
    {
      driver.debug("TypeDef => DefinitionAttrs tok_typedef FieldType "
          "Identifier TypeAnnotations");
      yylhs.value.as < t_typedef* > () = new t_typedef(driver.program, consume(yystack_[3].value.as < t_type_ref* > ()), std::move(yystack_[2].value.as < std::string > ()), driver.scope_cache);
      driver.finish_node(yylhs.value.as < t_typedef* > (), LineType::Typedef, own(yystack_[5].value.as < t_def_attrs* > ()), own(yystack_[0].value.as < t_annotations* > ()));
    }
#line 1849 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 37: // CommaOrSemicolon: ","
#line 533 "parse/thrifty.yy"
    {}
#line 1855 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 38: // CommaOrSemicolon: ";"
#line 535 "parse/thrifty.yy"
    {}
#line 1861 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 39: // CommaOrSemicolonOptional: CommaOrSemicolon
#line 539 "parse/thrifty.yy"
    {
      yylhs.value.as < bool > () = true;
    }
#line 1869 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 40: // CommaOrSemicolonOptional: %empty
#line 543 "parse/thrifty.yy"
    {
      yylhs.value.as < bool > () = false;
    }
#line 1877 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 41: // $@2: %empty
#line 549 "parse/thrifty.yy"
    {
      driver.start_node(LineType::Enum);
    }
#line 1885 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 42: // Enum: DefinitionAttrs tok_enum Identifier $@2 "{" EnumDefList "}" TypeAnnotations
#line 553 "parse/thrifty.yy"
    {
      driver.debug("Enum => DefinitionAttrs tok_enum Identifier { EnumDefList } TypeAnnotations");
      yystack_[2].value.as < t_enum* > ()->set_name(std::move(yystack_[5].value.as < std::string > ()));
      driver.finish_node(yystack_[2].value.as < t_enum* > (), LineType::Enum, own(yystack_[7].value.as < t_def_attrs* > ()), own(yystack_[0].value.as < t_annotations* > ()));
      yylhs.value.as < t_enum* > () = yystack_[2].value.as < t_enum* > ();
    }
#line 1896 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 43: // EnumDefList: EnumDefList EnumDef
#line 562 "parse/thrifty.yy"
    {
      driver.debug("EnumDefList -> EnumDefList EnumDef");
      yylhs.value.as < t_enum* > () = yystack_[1].value.as < t_enum* > ();
      yylhs.value.as < t_enum* > ()->append(own(yystack_[0].value.as < t_enum_value* > ()));
    }
#line 1906 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 44: // EnumDefList: %empty
#line 568 "parse/thrifty.yy"
    {
      driver.debug("EnumDefList -> ");
      yylhs.value.as < t_enum* > () = new t_enum(driver.program);
    }
#line 1915 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 45: // $@3: %empty
#line 575 "parse/thrifty.yy"
    {
      driver.start_node(LineType::EnumValue);
    }
#line 1923 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 46: // EnumDef: DefinitionAttrs EnumValue $@3 TypeAnnotations CommaOrSemicolonOptional
#line 579 "parse/thrifty.yy"
    {
      driver.debug("EnumDef => DefinitionAttrs EnumValue "
        "TypeAnnotations CommaOrSemicolonOptional");
      driver.finish_node(yystack_[3].value.as < t_enum_value* > (), LineType::EnumValue, own(yystack_[4].value.as < t_def_attrs* > ()), own(yystack_[1].value.as < t_annotations* > ()));
      yylhs.value.as < t_enum_value* > () = yystack_[3].value.as < t_enum_value* > ();
    }
#line 1934 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 47: // EnumValue: Identifier "=" tok_int_constant
#line 588 "parse/thrifty.yy"
    {
      driver.debug("EnumValue -> Identifier = tok_int_constant");
      if (yystack_[0].value.as < int64_t > () < 0 && !driver.params.allow_neg_enum_vals) {
        driver.warning(1, "Negative value supplied for enum %s.", yystack_[2].value.as < std::string > ().c_str());
      }
      if (yystack_[0].value.as < int64_t > () < INT32_MIN || yystack_[0].value.as < int64_t > () > INT32_MAX) {
        // Note: this used to be just a warning.  However, since thrift always
        // treats enums as i32 values, I'm changing it to a fatal error.
        // I doubt this will affect many people, but users who run into this
        // will have to update their thrift files to manually specify the
        // truncated i32 value that thrift has always been using anyway.
        driver.failure("64-bit value supplied for enum %s will be truncated.", yystack_[2].value.as < std::string > ().c_str());
      }
      yylhs.value.as < t_enum_value* > () = new t_enum_value;
      yylhs.value.as < t_enum_value* > ()->set_name(yystack_[2].value.as < std::string > ());
      yylhs.value.as < t_enum_value* > ()->set_value(yystack_[0].value.as < int64_t > ());
      yylhs.value.as < t_enum_value* > ()->set_lineno(driver.scanner->get_lineno());
    }
#line 1957 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 48: // EnumValue: Identifier
#line 608 "parse/thrifty.yy"
    {
      driver.debug("EnumValue -> Identifier");
      yylhs.value.as < t_enum_value* > () = new t_enum_value;
      yylhs.value.as < t_enum_value* > ()->set_name(yystack_[0].value.as < std::string > ());
      yylhs.value.as < t_enum_value* > ()->set_lineno(driver.scanner->get_lineno());
    }
#line 1968 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 49: // $@4: %empty
#line 617 "parse/thrifty.yy"
    {
      driver.start_node(LineType::Const);
    }
#line 1976 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 50: // Const: DefinitionAttrs tok_const FieldType Identifier $@4 "=" ConstValue TypeAnnotations CommaOrSemicolonOptional
#line 621 "parse/thrifty.yy"
    {
      driver.debug("DefinitionAttrs Const => tok_const FieldType Identifier = ConstValue");
      if (driver.mode == parsing_mode::PROGRAM) {
        yylhs.value.as < t_const* > () = new t_const(driver.program, consume(yystack_[6].value.as < t_type_ref* > ()), std::move(yystack_[5].value.as < std::string > ()), own(yystack_[2].value.as < t_const_value* > ()));
        driver.finish_node(yylhs.value.as < t_const* > (), LineType::Const, own(yystack_[8].value.as < t_def_attrs* > ()), own(yystack_[1].value.as < t_annotations* > ()));
      } else {
        // TODO(afuller): Looks like a bug where driver.finish_node is never called in this case.
        delete yystack_[8].value.as < t_def_attrs* > ();
        delete yystack_[6].value.as < t_type_ref* > ();
        delete yystack_[2].value.as < t_const_value* > ();
        delete yystack_[1].value.as < t_annotations* > ();
        yylhs.value.as < t_const* > () = nullptr;
      }
    }
#line 1995 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 51: // ConstValue: tok_bool_constant
#line 638 "parse/thrifty.yy"
    {
      driver.debug("ConstValue => tok_int_constant");
      yylhs.value.as < t_const_value* > () = new t_const_value();
      yylhs.value.as < t_const_value* > ()->set_bool(yystack_[0].value.as < int64_t > ());
    }
#line 2005 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 52: // ConstValue: tok_int_constant
#line 644 "parse/thrifty.yy"
    {
      driver.debug("ConstValue => tok_int_constant");
      yylhs.value.as < t_const_value* > () = new t_const_value();
      yylhs.value.as < t_const_value* > ()->set_integer(yystack_[0].value.as < int64_t > ());
      if (driver.mode == parsing_mode::PROGRAM) {
        if (!driver.params.allow_64bit_consts && (yystack_[0].value.as < int64_t > () < INT32_MIN || yystack_[0].value.as < int64_t > () > INT32_MAX)) {
          driver.warning(1, "64-bit constant \"%" PRIi64 "\" may not work in all languages.", yystack_[0].value.as < int64_t > ());
        }
      }
    }
#line 2020 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 53: // ConstValue: tok_dub_constant
#line 655 "parse/thrifty.yy"
    {
      driver.debug("ConstValue => tok_dub_constant");
      yylhs.value.as < t_const_value* > () = new t_const_value();
      yylhs.value.as < t_const_value* > ()->set_double(yystack_[0].value.as < double > ());
    }
#line 2030 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 54: // ConstValue: tok_literal
#line 661 "parse/thrifty.yy"
    {
      driver.debug("ConstValue => tok_literal");
      yylhs.value.as < t_const_value* > () = new t_const_value(yystack_[0].value.as < std::string > ());
    }
#line 2039 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 55: // ConstValue: Identifier
#line 666 "parse/thrifty.yy"
    {
      driver.debug("ConstValue => Identifier");
      const t_const* constant = driver.scope_cache->get_constant(yystack_[0].value.as < std::string > ());
      driver.validate_not_ambiguous_enum(yystack_[0].value.as < std::string > ());
      if (constant == nullptr) {
        auto name_with_program_name = driver.program->name() + "." + yystack_[0].value.as < std::string > ();
        constant = driver.scope_cache->get_constant(name_with_program_name);
        driver.validate_not_ambiguous_enum(name_with_program_name);
      }
      if (constant != nullptr) {
        // Copy const_value to perform isolated mutations
        t_const_value* const_value = constant->get_value();
        yylhs.value.as < t_const_value* > () = const_value->clone().release();

        // We only want to clone the value, while discarding all real type
        // information.
        yylhs.value.as < t_const_value* > ()->set_ttype(nullptr);
        yylhs.value.as < t_const_value* > ()->set_is_enum(false);
        yylhs.value.as < t_const_value* > ()->set_enum(nullptr);
        yylhs.value.as < t_const_value* > ()->set_enum_value(nullptr);
      } else {
        if (driver.mode == parsing_mode::PROGRAM) {
          driver.warning(1, "Constant strings should be quoted: %s", yystack_[0].value.as < std::string > ().c_str());
        }
        yylhs.value.as < t_const_value* > () = new t_const_value(yystack_[0].value.as < std::string > ());
      }
    }
#line 2071 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 56: // ConstValue: ConstList
#line 694 "parse/thrifty.yy"
    {
      driver.debug("ConstValue => ConstList");
      yylhs.value.as < t_const_value* > () = yystack_[0].value.as < t_const_value* > ();
    }
#line 2080 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 57: // ConstValue: ConstMap
#line 699 "parse/thrifty.yy"
    {
      driver.debug("ConstValue => ConstMap");
      yylhs.value.as < t_const_value* > () = yystack_[0].value.as < t_const_value* > ();
    }
#line 2089 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 58: // ConstValue: ConstStruct
#line 704 "parse/thrifty.yy"
    {
      driver.debug("ConstValue => ConstStruct");
      yylhs.value.as < t_const_value* > () = yystack_[0].value.as < t_const_value* > ();
    }
#line 2098 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 59: // ConstList: "[" ConstListContents CommaOrSemicolonOptional "]"
#line 711 "parse/thrifty.yy"
    {
      driver.debug("ConstList => [ ConstListContents CommaOrSemicolonOptional ]");
      yylhs.value.as < t_const_value* > () = yystack_[2].value.as < t_const_value* > ();
    }
#line 2107 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 60: // ConstList: "[" "]"
#line 716 "parse/thrifty.yy"
    {
      driver.debug("ConstList => [ ]");
      yylhs.value.as < t_const_value* > () = new t_const_value();
      yylhs.value.as < t_const_value* > ()->set_list();
    }
#line 2117 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 61: // ConstListContents: ConstListContents CommaOrSemicolon ConstValue
#line 724 "parse/thrifty.yy"
    {
      driver.debug("ConstListContents => ConstListContents CommaOrSemicolon ConstValue");
      yylhs.value.as < t_const_value* > () = yystack_[2].value.as < t_const_value* > ();
      yylhs.value.as < t_const_value* > ()->add_list(own(yystack_[0].value.as < t_const_value* > ()));
    }
#line 2127 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 62: // ConstListContents: ConstValue
#line 730 "parse/thrifty.yy"
    {
      driver.debug("ConstListContents => ConstValue");
      yylhs.value.as < t_const_value* > () = new t_const_value();
      yylhs.value.as < t_const_value* > ()->set_list();
      yylhs.value.as < t_const_value* > ()->add_list(own(yystack_[0].value.as < t_const_value* > ()));
    }
#line 2138 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 63: // ConstMap: "{" ConstMapContents CommaOrSemicolonOptional "}"
#line 739 "parse/thrifty.yy"
    {
      driver.debug("ConstMap => { ConstMapContents CommaOrSemicolonOptional }");
      yylhs.value.as < t_const_value* > () = yystack_[2].value.as < t_const_value* > ();
    }
#line 2147 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 64: // ConstMap: "{" "}"
#line 745 "parse/thrifty.yy"
    {
      driver.debug("ConstMap => { }");
      yylhs.value.as < t_const_value* > () = new t_const_value();
      yylhs.value.as < t_const_value* > ()->set_map();
    }
#line 2157 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 65: // ConstMapContents: ConstMapContents CommaOrSemicolon ConstValue ":" ConstValue
#line 753 "parse/thrifty.yy"
    {
      driver.debug("ConstMapContents => ConstMapContents CommaOrSemicolon ConstValue : ConstValue");
      yylhs.value.as < t_const_value* > () = yystack_[4].value.as < t_const_value* > ();
      yylhs.value.as < t_const_value* > ()->add_map(own(yystack_[2].value.as < t_const_value* > ()), own(yystack_[0].value.as < t_const_value* > ()));
    }
#line 2167 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 66: // ConstMapContents: ConstValue ":" ConstValue
#line 759 "parse/thrifty.yy"
    {
      driver.debug("ConstMapContents => ConstValue : ConstValue");
      yylhs.value.as < t_const_value* > () = new t_const_value();
      yylhs.value.as < t_const_value* > ()->set_map();
      yylhs.value.as < t_const_value* > ()->add_map(own(yystack_[2].value.as < t_const_value* > ()), own(yystack_[0].value.as < t_const_value* > ()));
    }
#line 2178 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 67: // ConstStruct: ConstStructType "{" ConstStructContents CommaOrSemicolonOptional "}"
#line 768 "parse/thrifty.yy"
    {
      driver.debug("ConstStruct => ConstStructType { ConstStructContents CommaOrSemicolonOptional }");
      yylhs.value.as < t_const_value* > () = yystack_[2].value.as < t_const_value* > ();
      yylhs.value.as < t_const_value* > ()->set_ttype(own(yystack_[4].value.as < t_type_ref* > ()));
    }
#line 2188 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 68: // ConstStruct: ConstStructType "{" "}"
#line 774 "parse/thrifty.yy"
    {
      driver.debug("ConstStruct => ConstStructType { }");
      yylhs.value.as < t_const_value* > () = new t_const_value();
      yylhs.value.as < t_const_value* > ()->set_map();
      yylhs.value.as < t_const_value* > ()->set_ttype(own(yystack_[2].value.as < t_type_ref* > ()));
    }
#line 2199 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 69: // ConstStructType: Identifier
#line 783 "parse/thrifty.yy"
    {
      driver.debug("ConstStructType -> Identifier");
      yylhs.value.as < t_type_ref* > () = driver.new_type_ref(std::move(yystack_[0].value.as < std::string > ()), nullptr, /*is_const=*/true).release();
    }
#line 2208 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 70: // ConstStructContents: ConstStructContents CommaOrSemicolon Identifier "=" ConstValue
#line 790 "parse/thrifty.yy"
    {
      driver.debug("ConstStructContents => ConstStructContents CommaOrSemicolon Identifier = ConstValue");
      yylhs.value.as < t_const_value* > () = yystack_[4].value.as < t_const_value* > ();
      yylhs.value.as < t_const_value* > ()->add_map(std::make_unique<t_const_value>(yystack_[2].value.as < std::string > ()), own(yystack_[0].value.as < t_const_value* > ()));
    }
#line 2218 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 71: // ConstStructContents: Identifier "=" ConstValue
#line 796 "parse/thrifty.yy"
    {
      driver.debug("ConstStructContents => Identifier = ConstValue");
      yylhs.value.as < t_const_value* > () = new t_const_value();
      yylhs.value.as < t_const_value* > ()->set_map();
      yylhs.value.as < t_const_value* > ()->add_map(std::make_unique<t_const_value>(yystack_[2].value.as < std::string > ()), own(yystack_[0].value.as < t_const_value* > ()));
    }
#line 2229 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 72: // $@5: %empty
#line 805 "parse/thrifty.yy"
    {
      driver.start_node(LineType::Struct);
    }
#line 2237 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 73: // Struct: DefinitionAttrs tok_struct Identifier $@5 "{" FieldList "}" TypeAnnotations
#line 809 "parse/thrifty.yy"
    {
      driver.debug("Struct => DefinitionAttrs tok_struct Identifier "
        "{ FieldList } TypeAnnotations");
      yylhs.value.as < t_struct* > () = new t_struct(driver.program, std::move(yystack_[5].value.as < std::string > ()));
      driver.finish_node(yylhs.value.as < t_struct* > (), LineType::Struct, own(yystack_[7].value.as < t_def_attrs* > ()), own(yystack_[2].value.as < t_field_list* > ()), own(yystack_[0].value.as < t_annotations* > ()));
      y_field_val = -1;
    }
#line 2249 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 74: // $@6: %empty
#line 819 "parse/thrifty.yy"
    {
      driver.start_node(LineType::Union);
    }
#line 2257 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 75: // Union: DefinitionAttrs tok_union Identifier $@6 "{" FieldList "}" TypeAnnotations
#line 823 "parse/thrifty.yy"
    {
      driver.debug("Union => DefinitionAttrs tok_union Identifier "
        "{ FieldList } TypeAnnotations");
      yylhs.value.as < t_union* > () = new t_union(driver.program, std::move(yystack_[5].value.as < std::string > ()));
      driver.finish_node(yylhs.value.as < t_union* > (), LineType::Union, own(yystack_[7].value.as < t_def_attrs* > ()), own(yystack_[2].value.as < t_field_list* > ()), own(yystack_[0].value.as < t_annotations* > ()));
      y_field_val = -1;
    }
#line 2269 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 76: // $@7: %empty
#line 834 "parse/thrifty.yy"
    {
      driver.start_node(LineType::Exception);
    }
#line 2277 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 77: // Exception: DefinitionAttrs ErrorSafety ErrorKind ErrorBlame tok_exception Identifier $@7 "{" FieldList "}" TypeAnnotations
#line 838 "parse/thrifty.yy"
    {
      driver.debug("Exception => DefinitionAttrs tok_exception "
        "Identifier { FieldList } TypeAnnotations");
      yylhs.value.as < t_exception* > () = new t_exception(driver.program, std::move(yystack_[5].value.as < std::string > ()));
      yylhs.value.as < t_exception* > ()->set_safety(yystack_[9].value.as < t_error_safety > ());
      yylhs.value.as < t_exception* > ()->set_kind(yystack_[8].value.as < t_error_kind > ());
      yylhs.value.as < t_exception* > ()->set_blame(yystack_[7].value.as < t_error_blame > ());
      driver.finish_node(yylhs.value.as < t_exception* > (), LineType::Exception, own(yystack_[10].value.as < t_def_attrs* > ()), own(yystack_[2].value.as < t_field_list* > ()), own(yystack_[0].value.as < t_annotations* > ()));

      const char* annotations[] = {"message", "code"};
      for (auto& annotation: annotations) {
        if (driver.mode == parsing_mode::PROGRAM
            && yylhs.value.as < t_exception* > ()->get_field_by_name(annotation) != nullptr
            && yylhs.value.as < t_exception* > ()->has_annotation(annotation)
            && strcmp(annotation, yylhs.value.as < t_exception* > ()->get_annotation(annotation).c_str()) != 0) {
          driver.warning(1, "Some generators (e.g. PHP) will ignore annotation '%s' "
                         "as it is also used as field", annotation);
        }
      }

      // Check that value of "message" annotation is
      // - a valid member of struct
      // - of type STRING
      if (driver.mode == parsing_mode::PROGRAM && yylhs.value.as < t_exception* > ()->has_annotation("message")) {
        const std::string& v = yylhs.value.as < t_exception* > ()->get_annotation("message");
        const auto* field = yylhs.value.as < t_exception* > ()->get_field_by_name(v);
        if (field == nullptr) {
          driver.failure("member specified as exception 'message' should be a valid"
                         " struct member, '%s' in '%s' is not", v.c_str(), yylhs.value.as < t_exception* > ()->name().c_str());
        }

        if (!field->get_type()->is_string_or_binary()) {
          driver.failure("member specified as exception 'message' should be of type "
                         "STRING, '%s' in '%s' is not", v.c_str(), yylhs.value.as < t_exception* > ()->name().c_str());
        }
      }

      y_field_val = -1;
    }
#line 2321 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 78: // ErrorSafety: tok_safe
#line 880 "parse/thrifty.yy"
    {
      driver.require_experimental_feature("error-classification");
      yylhs.value.as < t_error_safety > () = t_error_safety::safe;
    }
#line 2330 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 79: // ErrorSafety: %empty
#line 885 "parse/thrifty.yy"
    {
      yylhs.value.as < t_error_safety > () = {};
    }
#line 2338 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 80: // ErrorKind: tok_transient
#line 891 "parse/thrifty.yy"
    {
      driver.require_experimental_feature("error-classification");
      yylhs.value.as < t_error_kind > () = t_error_kind::transient;
    }
#line 2347 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 81: // ErrorKind: tok_stateful
#line 897 "parse/thrifty.yy"
    {
      driver.require_experimental_feature("error-classification");
      yylhs.value.as < t_error_kind > () = t_error_kind::stateful;
    }
#line 2356 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 82: // ErrorKind: tok_permanent
#line 903 "parse/thrifty.yy"
    {
      driver.require_experimental_feature("error-classification");
      yylhs.value.as < t_error_kind > () = t_error_kind::permanent;
    }
#line 2365 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 83: // ErrorKind: %empty
#line 908 "parse/thrifty.yy"
    {
      yylhs.value.as < t_error_kind > () = {};
    }
#line 2373 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 84: // ErrorBlame: tok_client
#line 914 "parse/thrifty.yy"
    {
      driver.require_experimental_feature("error-classification");
      yylhs.value.as < t_error_blame > () = t_error_blame::client;
    }
#line 2382 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 85: // ErrorBlame: tok_server
#line 920 "parse/thrifty.yy"
    {
      driver.require_experimental_feature("error-classification");
      yylhs.value.as < t_error_blame > () = t_error_blame::server;
    }
#line 2391 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 86: // ErrorBlame: %empty
#line 925 "parse/thrifty.yy"
    {
      yylhs.value.as < t_error_blame > () = {};
    }
#line 2399 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 87: // $@8: %empty
#line 932 "parse/thrifty.yy"
    {
      driver.start_node(LineType::Service);
    }
#line 2407 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 88: // Service: DefinitionAttrs tok_service Identifier $@8 Extends "{" FlagArgs FunctionList UnflagArgs "}" FunctionAnnotations
#line 936 "parse/thrifty.yy"
    {
      driver.debug("Service => DefinitionAttrs tok_service "
        "Identifier Extends { FlagArgs FunctionList UnflagArgs } "
        "FunctionAnnotations");
      yylhs.value.as < t_service* > () = new t_service(driver.program, std::move(yystack_[8].value.as < std::string > ()), yystack_[6].value.as < t_ref<t_service> > ());
      driver.finish_node(yylhs.value.as < t_service* > (), LineType::Service, own(yystack_[10].value.as < t_def_attrs* > ()), own(yystack_[3].value.as < t_function_list* > ()), own(yystack_[0].value.as < t_annotations* > ()));
    }
#line 2419 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 89: // FlagArgs: %empty
#line 945 "parse/thrifty.yy"
    {
       g_arglist = 1;
    }
#line 2427 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 90: // UnflagArgs: %empty
#line 950 "parse/thrifty.yy"
    {
       g_arglist = 0;
    }
#line 2435 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 91: // Extends: tok_extends Identifier
#line 956 "parse/thrifty.yy"
    {
      driver.debug("Extends -> tok_extends Identifier");
      yylhs.value.as < t_ref<t_service> > () = nullptr;
      if (driver.mode == parsing_mode::PROGRAM) {
        yylhs.value.as < t_ref<t_service> > () = driver.scope_cache->get_service(yystack_[0].value.as < std::string > ());
        if (!yylhs.value.as < t_ref<t_service> > ()) {
          yylhs.value.as < t_ref<t_service> > () = driver.scope_cache->get_service(driver.program->name() + "." + yystack_[0].value.as < std::string > ());
        }
        if (!yylhs.value.as < t_ref<t_service> > ()) {
          driver.failure("Service \"%s\" has not been defined.", yystack_[0].value.as < std::string > ().c_str());
        }
      }
    }
#line 2453 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 92: // Extends: %empty
#line 970 "parse/thrifty.yy"
    {
      yylhs.value.as < t_ref<t_service> > () = nullptr;
    }
#line 2461 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 93: // $@9: %empty
#line 976 "parse/thrifty.yy"
    {
      driver.start_node(LineType::Interaction);
    }
#line 2469 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 94: // Interaction: DefinitionAttrs tok_interaction Identifier $@9 "{" FlagArgs FunctionList UnflagArgs "}" TypeAnnotations
#line 980 "parse/thrifty.yy"
    {
      driver.debug("Interaction -> tok_interaction Identifier { FunctionList }");
      yylhs.value.as < t_interaction* > () = new t_interaction(driver.program, std::move(yystack_[7].value.as < std::string > ()));
      driver.finish_node(yylhs.value.as < t_interaction* > (), LineType::Interaction, own(yystack_[9].value.as < t_def_attrs* > ()), own(yystack_[3].value.as < t_function_list* > ()), own(yystack_[0].value.as < t_annotations* > ()));

      // TODO(afuller): Move this to a post parse phase.
      for (auto* func : yylhs.value.as < t_interaction* > ()->get_functions()) {
        func->set_is_interaction_member();
        if (func->has_annotation("thread")) {
          driver.failure("Interaction methods cannot be individually annotated with "
            "thread='eb'. Use process_in_event_base on the interaction instead.");
        }
      }
      if (yylhs.value.as < t_interaction* > ()->has_annotation("process_in_event_base")) {
        if (yylhs.value.as < t_interaction* > ()->has_annotation("serial")) {
          driver.failure("EB interactions are already serial");
        }
        for (auto* func : yylhs.value.as < t_interaction* > ()->get_functions()) {
          func->set_annotation("thread", "eb");
        }
      }
    }
#line 2496 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 95: // FunctionList: FunctionList Function
#line 1005 "parse/thrifty.yy"
    {
      driver.debug("FunctionList -> FunctionList Function");
      yystack_[1].value.as < t_function_list* > ()->emplace_back(own(yystack_[0].value.as < t_function* > ()));
      yylhs.value.as < t_function_list* > () = yystack_[1].value.as < t_function_list* > ();
    }
#line 2506 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 96: // FunctionList: %empty
#line 1011 "parse/thrifty.yy"
    {
      driver.debug("FunctionList -> ");
      yylhs.value.as < t_function_list* > () = new t_function_list;
    }
#line 2515 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 97: // $@10: %empty
#line 1018 "parse/thrifty.yy"
    {
      driver.start_node(LineType::Function);
    }
#line 2523 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 98: // Function: DefinitionAttrs FunctionQualifier FunctionType Identifier $@10 "(" ParamList ")" MaybeThrows FunctionAnnotations CommaOrSemicolonOptional
#line 1022 "parse/thrifty.yy"
    {
      driver.debug("Function => DefinitionAttrs FunctionQualifier "
        "FunctionType Identifier ( ParamList ) MaybeThrows "
        "FunctionAnnotations CommaOrSemicolonOptional");
      // TODO(afuller): Leave the param list unnamed.
      yystack_[4].value.as < t_paramlist* > ()->set_name(std::string(yystack_[7].value.as < std::string > ()) + "_args");
      yylhs.value.as < t_function* > () = new t_function(
        consume(yystack_[8].value.as < t_type_ref* > ()),
        std::move(yystack_[7].value.as < std::string > ()),
        own(yystack_[4].value.as < t_paramlist* > ()),
        own(yystack_[2].value.as < t_throws* > ()),
        yystack_[9].value.as < t_function_qualifier > ()
      );
      driver.finish_node(yylhs.value.as < t_function* > (), LineType::Function, own(yystack_[10].value.as < t_def_attrs* > ()), own(yystack_[1].value.as < t_annotations* > ()));
      y_field_val = -1;
    }
#line 2544 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 99: // Function: tok_performs FieldType ";"
#line 1039 "parse/thrifty.yy"
    {
      driver.debug("Function => tok_performs FieldType");
      auto ret = own(yystack_[1].value.as < t_type_ref* > ());
      std::string name = ret->type()
          ? "create" + ret->type()->get_name()
          : "<interaction placeholder>";
      yylhs.value.as < t_function* > () = new t_function(
        std::move(*ret),
        std::move(name),
        std::make_unique<t_paramlist>(driver.program)
      );
      yylhs.value.as < t_function* > ()->set_lineno(driver.scanner->get_lineno());
      yylhs.value.as < t_function* > ()->set_is_interaction_constructor();
    }
#line 2563 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 100: // ParamList: ParamList Param
#line 1056 "parse/thrifty.yy"
    {
      driver.debug("ParamList -> ParamList , Param");
      yylhs.value.as < t_paramlist* > () = yystack_[1].value.as < t_paramlist* > ();
      auto param = own(yystack_[0].value.as < t_field* > ());
      if (!yylhs.value.as < t_paramlist* > ()->try_append_field(std::move(param))) {
        driver.failure("Parameter identifier %d for \"%s\" has already been used",
                       param->get_key(), param->get_name().c_str());
      }
    }
#line 2577 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 101: // ParamList: EmptyParamList
#line 1066 "parse/thrifty.yy"
    {
      yylhs.value.as < t_paramlist* > () = yystack_[0].value.as < t_paramlist* > ();
    }
#line 2585 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 102: // EmptyParamList: %empty
#line 1071 "parse/thrifty.yy"
    {
      driver.debug("EmptyParamList -> nil");
      yylhs.value.as < t_paramlist* > () = new t_paramlist(driver.program);
    }
#line 2594 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 103: // Param: Field
#line 1078 "parse/thrifty.yy"
    {
      driver.debug("Param -> Field");
      yylhs.value.as < t_field* > () = yystack_[0].value.as < t_field* > ();
    }
#line 2603 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 104: // FunctionQualifier: tok_oneway
#line 1085 "parse/thrifty.yy"
    {
      yylhs.value.as < t_function_qualifier > () = t_function_qualifier::one_way;
    }
#line 2611 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 105: // FunctionQualifier: tok_idempotent
#line 1089 "parse/thrifty.yy"
    {
      driver.require_experimental_feature("idempotency");
      yylhs.value.as < t_function_qualifier > () = t_function_qualifier::idempotent;
    }
#line 2620 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 106: // FunctionQualifier: tok_readonly
#line 1094 "parse/thrifty.yy"
    {
      driver.require_experimental_feature("idempotency");
      yylhs.value.as < t_function_qualifier > () = t_function_qualifier::read_only;
    }
#line 2629 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 107: // FunctionQualifier: %empty
#line 1099 "parse/thrifty.yy"
    {
      yylhs.value.as < t_function_qualifier > () = t_function_qualifier::none;
    }
#line 2637 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 108: // Throws: tok_throws "(" FieldList ")"
#line 1105 "parse/thrifty.yy"
    {
      driver.debug("Throws -> tok_throws ( FieldList )");
      yylhs.value.as < t_throws* > () = driver.new_throws(own(yystack_[1].value.as < t_field_list* > ())).release();
    }
#line 2646 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 109: // MaybeThrows: Throws
#line 1111 "parse/thrifty.yy"
                {
			yylhs.value.as < t_throws* > () = yystack_[0].value.as < t_throws* > ();
		}
#line 2654 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 110: // MaybeThrows: %empty
#line 1114 "parse/thrifty.yy"
    {
      yylhs.value.as < t_throws* > () = driver.new_throws().release();
		}
#line 2662 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 111: // FieldList: FieldList Field
#line 1120 "parse/thrifty.yy"
    {
      driver.debug("FieldList -> FieldList Field");
      yylhs.value.as < t_field_list* > () = yystack_[1].value.as < t_field_list* > ();
      yylhs.value.as < t_field_list* > ()->emplace_back(yystack_[0].value.as < t_field* > ());
    }
#line 2672 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 112: // FieldList: %empty
#line 1126 "parse/thrifty.yy"
    {
      driver.debug("FieldList -> ");
      yylhs.value.as < t_field_list* > () = new t_field_list;
    }
#line 2681 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 113: // $@11: %empty
#line 1133 "parse/thrifty.yy"
    {
      driver.start_node(LineType::Field);
    }
#line 2689 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 114: // Field: DefinitionAttrs FieldIdentifier FieldRequiredness FieldType Identifier $@11 FieldValue TypeAnnotations CommaOrSemicolonOptional
#line 1137 "parse/thrifty.yy"
    {
      driver.debug("Field => DefinitionAttrs FieldIdentifier FieldRequiredness "
        "FieldType Identifier FieldValue TypeAnnotations CommaOrSemicolonOptional");
      if (yystack_[7].value.as < t_field_id > ().auto_assigned) {
        driver.warning(1, "No field key specified for %s, resulting protocol may have conflicts "
          "or not be backwards compatible!", yystack_[4].value.as < std::string > ().c_str());
        if (driver.params.strict >= 192) {
          driver.failure("Implicit field keys are deprecated and not allowed with -strict");
        }
      }

      yylhs.value.as < t_field* > () = new t_field(consume(yystack_[5].value.as < t_type_ref* > ()), std::move(yystack_[4].value.as < std::string > ()), yystack_[7].value.as < t_field_id > ().value);
      yylhs.value.as < t_field* > ()->set_req(yystack_[6].value.as < t_field::e_req > ());
      if (yystack_[2].value.as < t_const_value* > () != nullptr) {
        driver.validate_field_value(yylhs.value.as < t_field* > (), yystack_[2].value.as < t_const_value* > ());
        yylhs.value.as < t_field* > ()->set_value(own(yystack_[2].value.as < t_const_value* > ()));
      }
      driver.finish_node(yylhs.value.as < t_field* > (), LineType::Field, own(yystack_[8].value.as < t_def_attrs* > ()), own(yystack_[1].value.as < t_annotations* > ()));

      if (yystack_[6].value.as < t_field::e_req > () != t_field::e_req::optional && yylhs.value.as < t_field* > ()->has_annotation({"cpp.ref", "cpp2.ref"})) {
        driver.warning(1, "`cpp.ref` field must be optional if it is recursive.");
      }
    }
#line 2717 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 115: // FieldIdentifier: tok_int_constant ":"
#line 1163 "parse/thrifty.yy"
    {
      if (yystack_[1].value.as < int64_t > () <= 0) {
        if (driver.params.allow_neg_field_keys) {
          /*
           * allow_neg_field_keys exists to allow users to add explicitly
           * specified key values to old .thrift files without breaking
           * protocol compatibility.
           */
          if (yystack_[1].value.as < int64_t > () != y_field_val) {
            /*
             * warn if the user-specified negative value isn't what
             * thrift would have auto-assigned.
             */
            driver.warning(1, "Negative field key (%d) differs from what would be "
                           "auto-assigned by thrift (%d).", yystack_[1].value.as < int64_t > (), y_field_val);
          }
          /*
           * Leave $1 as-is, and update y_field_val to be one less than $1.
           * The FieldList parsing will catch any duplicate key values.
           */
          y_field_val = yystack_[1].value.as < int64_t > () - 1;
          yylhs.value.as < t_field_id > ().value = yystack_[1].value.as < int64_t > ();
          yylhs.value.as < t_field_id > ().auto_assigned = false;
        } else {
          driver.warning(1, "Nonpositive value (%d) not allowed as a field key.",
                         yystack_[1].value.as < int64_t > ());
          yylhs.value.as < t_field_id > ().value = y_field_val--;
          yylhs.value.as < t_field_id > ().auto_assigned = true;
        }
      } else {
        yylhs.value.as < t_field_id > ().value = yystack_[1].value.as < int64_t > ();
        yylhs.value.as < t_field_id > ().auto_assigned = false;
      }
    }
#line 2756 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 116: // FieldIdentifier: %empty
#line 1198 "parse/thrifty.yy"
    {
      yylhs.value.as < t_field_id > ().value = y_field_val--;
      yylhs.value.as < t_field_id > ().auto_assigned = true;
    }
#line 2765 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 117: // FieldRequiredness: tok_required
#line 1205 "parse/thrifty.yy"
    {
      if (g_arglist) {
        if (driver.mode == parsing_mode::PROGRAM) {
          driver.warning(1, "required keyword is ignored in argument lists.");
        }
        yylhs.value.as < t_field::e_req > () = t_field::e_req::opt_in_req_out;
      } else {
        yylhs.value.as < t_field::e_req > () = t_field::e_req::required;
      }
    }
#line 2780 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 118: // FieldRequiredness: tok_optional
#line 1216 "parse/thrifty.yy"
    {
      if (g_arglist) {
        if (driver.mode == parsing_mode::PROGRAM) {
          driver.warning(1, "optional keyword is ignored in argument lists.");
        }
        yylhs.value.as < t_field::e_req > () = t_field::e_req::opt_in_req_out;
      } else {
        yylhs.value.as < t_field::e_req > () = t_field::e_req::optional;
      }
    }
#line 2795 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 119: // FieldRequiredness: %empty
#line 1227 "parse/thrifty.yy"
    {
      yylhs.value.as < t_field::e_req > () = t_field::e_req::opt_in_req_out;
    }
#line 2803 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 120: // FieldValue: "=" ConstValue
#line 1233 "parse/thrifty.yy"
    {
      if (driver.mode == parsing_mode::PROGRAM) {
        yylhs.value.as < t_const_value* > () = yystack_[0].value.as < t_const_value* > ();
      } else {
        delete yystack_[0].value.as < t_const_value* > ();
        yylhs.value.as < t_const_value* > () = nullptr;
      }
    }
#line 2816 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 121: // FieldValue: %empty
#line 1242 "parse/thrifty.yy"
    {
      yylhs.value.as < t_const_value* > () = nullptr;
    }
#line 2824 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 122: // FunctionType: ResponseAndStreamReturnType
#line 1248 "parse/thrifty.yy"
    {
      driver.debug("FunctionType -> ResponseAndStreamReturnType");
      yylhs.value.as < t_type_ref* > () = driver.new_type_ref(own(yystack_[0].value.as < t_stream_response* > ()), nullptr).release();
    }
#line 2833 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 123: // FunctionType: ResponseAndSinkReturnType
#line 1253 "parse/thrifty.yy"
    {
      driver.debug("FunctionType -> ResponseAndSinkReturnType");
      yylhs.value.as < t_type_ref* > () = driver.new_type_ref(own(yystack_[0].value.as < t_sink* > ()), nullptr).release();
    }
#line 2842 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 124: // FunctionType: FieldType
#line 1258 "parse/thrifty.yy"
    {
      driver.debug("FunctionType -> FieldType");
      yylhs.value.as < t_type_ref* > () = yystack_[0].value.as < t_type_ref* > ();
    }
#line 2851 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 125: // FunctionType: tok_void
#line 1263 "parse/thrifty.yy"
    {
      driver.debug("FunctionType -> tok_void");
      yylhs.value.as < t_type_ref* > () = new t_type_ref(&t_base_type::t_void());
    }
#line 2860 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 126: // ResponseAndStreamReturnType: FieldType "," StreamReturnType
#line 1270 "parse/thrifty.yy"
    {
      driver.debug("ResponseAndStreamReturnType -> FieldType, StreamReturnType");
      yystack_[0].value.as < t_stream_response* > ()->set_first_response_type(own(yystack_[2].value.as < t_type_ref* > ()));
      yylhs.value.as < t_stream_response* > () = yystack_[0].value.as < t_stream_response* > ();
    }
#line 2870 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 127: // ResponseAndStreamReturnType: StreamReturnType
#line 1276 "parse/thrifty.yy"
    {
      driver.debug("ResponseAndStreamReturnType -> StreamReturnType");
      yylhs.value.as < t_stream_response* > () = yystack_[0].value.as < t_stream_response* > ();
    }
#line 2879 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 128: // StreamReturnType: tok_stream "<" FieldType ">"
#line 1283 "parse/thrifty.yy"
  {
    driver.debug("StreamReturnType -> tok_stream < FieldType >");
    yylhs.value.as < t_stream_response* > () = new t_stream_response(consume(yystack_[1].value.as < t_type_ref* > ()));
  }
#line 2888 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 129: // StreamReturnType: tok_stream "<" FieldType Throws ">"
#line 1288 "parse/thrifty.yy"
  {
    driver.debug("StreamReturnType -> tok_stream < FieldType Throws >");
    yylhs.value.as < t_stream_response* > () = new t_stream_response(consume(yystack_[2].value.as < t_type_ref* > ()), own(yystack_[1].value.as < t_throws* > ()));
  }
#line 2897 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 130: // ResponseAndSinkReturnType: FieldType "," SinkReturnType
#line 1295 "parse/thrifty.yy"
    {
      driver.debug("ResponseAndSinkReturnType -> FieldType, SinkReturnType");
      yystack_[0].value.as < t_sink* > ()->set_first_response_type(own(yystack_[2].value.as < t_type_ref* > ()));
      yylhs.value.as < t_sink* > () = yystack_[0].value.as < t_sink* > ();
    }
#line 2907 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 131: // ResponseAndSinkReturnType: SinkReturnType
#line 1301 "parse/thrifty.yy"
    {
      driver.debug("ResponseAndSinkReturnType -> SinkReturnType");
      yylhs.value.as < t_sink* > () = yystack_[0].value.as < t_sink* > ();
    }
#line 2916 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 132: // SinkReturnType: tok_sink "<" SinkFieldType "," SinkFieldType ">"
#line 1308 "parse/thrifty.yy"
    {
      driver.debug("SinkReturnType -> tok_sink<FieldType, FieldType>");
      yylhs.value.as < t_sink* > () = new t_sink(
        consume(yystack_[3].value.as < t_typethrowspair > ().first), own(yystack_[3].value.as < t_typethrowspair > ().second),
        consume(yystack_[1].value.as < t_typethrowspair > ().first), own(yystack_[1].value.as < t_typethrowspair > ().second));
    }
#line 2927 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 133: // SinkFieldType: FieldType
#line 1316 "parse/thrifty.yy"
    {
      yylhs.value.as < t_typethrowspair > () = std::make_pair(yystack_[0].value.as < t_type_ref* > (), nullptr);
    }
#line 2935 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 134: // SinkFieldType: FieldType Throws
#line 1320 "parse/thrifty.yy"
    {
      yylhs.value.as < t_typethrowspair > () = std::make_pair(yystack_[1].value.as < t_type_ref* > (), yystack_[0].value.as < t_throws* > ());
    }
#line 2943 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 135: // FieldType: Identifier TypeAnnotations
#line 1326 "parse/thrifty.yy"
    {
      driver.debug("FieldType => Identifier TypeAnnotations");
      yylhs.value.as < t_type_ref* > () = driver.new_type_ref(std::move(yystack_[1].value.as < std::string > ()), own(yystack_[0].value.as < t_annotations* > ())).release();
    }
#line 2952 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 136: // FieldType: BaseType TypeAnnotations
#line 1331 "parse/thrifty.yy"
    {
      driver.debug("FieldType -> BaseType");
      yylhs.value.as < t_type_ref* > () = driver.new_type_ref(yystack_[1].value.as < t_ref<t_base_type> > (), own(yystack_[0].value.as < t_annotations* > ())).release();
    }
#line 2961 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 137: // FieldType: ContainerType TypeAnnotations
#line 1336 "parse/thrifty.yy"
    {
      driver.debug("FieldType -> ContainerType");
      yylhs.value.as < t_type_ref* > () = driver.new_type_ref(own(yystack_[1].value.as < t_container* > ()), own(yystack_[0].value.as < t_annotations* > ())).release();
    }
#line 2970 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 138: // BaseType: tok_string
#line 1343 "parse/thrifty.yy"
    {
      driver.debug("BaseType -> tok_string");
      yylhs.value.as < t_ref<t_base_type> > () = &t_base_type::t_string();
    }
#line 2979 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 139: // BaseType: tok_binary
#line 1348 "parse/thrifty.yy"
    {
      driver.debug("BaseType -> tok_binary");
      yylhs.value.as < t_ref<t_base_type> > () = &t_base_type::t_binary();
    }
#line 2988 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 140: // BaseType: tok_bool
#line 1353 "parse/thrifty.yy"
    {
      driver.debug("BaseType -> tok_bool");
      yylhs.value.as < t_ref<t_base_type> > () = &t_base_type::t_bool();
    }
#line 2997 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 141: // BaseType: tok_byte
#line 1358 "parse/thrifty.yy"
    {
      driver.debug("BaseType -> tok_byte");
      yylhs.value.as < t_ref<t_base_type> > () = &t_base_type::t_byte();
    }
#line 3006 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 142: // BaseType: tok_i16
#line 1363 "parse/thrifty.yy"
    {
      driver.debug("BaseType -> tok_i16");
      yylhs.value.as < t_ref<t_base_type> > () = &t_base_type::t_i16();
    }
#line 3015 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 143: // BaseType: tok_i32
#line 1368 "parse/thrifty.yy"
    {
      driver.debug("BaseType -> tok_i32");
      yylhs.value.as < t_ref<t_base_type> > () = &t_base_type::t_i32();
    }
#line 3024 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 144: // BaseType: tok_i64
#line 1373 "parse/thrifty.yy"
    {
      driver.debug("BaseType -> tok_i64");
      yylhs.value.as < t_ref<t_base_type> > () = &t_base_type::t_i64();
    }
#line 3033 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 145: // BaseType: tok_double
#line 1378 "parse/thrifty.yy"
    {
      driver.debug("BaseType -> tok_double");
      yylhs.value.as < t_ref<t_base_type> > () = &t_base_type::t_double();
    }
#line 3042 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 146: // BaseType: tok_float
#line 1383 "parse/thrifty.yy"
    {
      driver.debug("BaseType -> tok_float");
      yylhs.value.as < t_ref<t_base_type> > () = &t_base_type::t_float();
    }
#line 3051 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 147: // ContainerType: MapType
#line 1390 "parse/thrifty.yy"
    {
      driver.debug("ContainerType -> MapType");
      yylhs.value.as < t_container* > () = yystack_[0].value.as < t_container* > ();
    }
#line 3060 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 148: // ContainerType: SetType
#line 1395 "parse/thrifty.yy"
    {
      driver.debug("ContainerType -> SetType");
      yylhs.value.as < t_container* > () = yystack_[0].value.as < t_container* > ();
    }
#line 3069 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 149: // ContainerType: ListType
#line 1400 "parse/thrifty.yy"
    {
      driver.debug("ContainerType -> ListType");
      yylhs.value.as < t_container* > () = yystack_[0].value.as < t_container* > ();
    }
#line 3078 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 150: // MapType: tok_map "<" FieldType "," FieldType ">"
#line 1407 "parse/thrifty.yy"
    {
      driver.debug("MapType -> tok_map<FieldType, FieldType>");
      yylhs.value.as < t_container* > () = new t_map(consume(yystack_[3].value.as < t_type_ref* > ()), consume(yystack_[1].value.as < t_type_ref* > ()));
    }
#line 3087 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 151: // SetType: tok_set "<" FieldType ">"
#line 1414 "parse/thrifty.yy"
    {
      driver.debug("SetType -> tok_set<FieldType>");
      yylhs.value.as < t_container* > () = new t_set(consume(yystack_[1].value.as < t_type_ref* > ()));
    }
#line 3096 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 152: // ListType: tok_list "<" FieldType ">"
#line 1421 "parse/thrifty.yy"
    {
      driver.debug("ListType -> tok_list<FieldType>");
      yylhs.value.as < t_container* > () = new t_list(consume(yystack_[1].value.as < t_type_ref* > ()));
    }
#line 3105 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 153: // $@12: %empty
#line 1428 "parse/thrifty.yy"
    {
      yystack_[1].value.as < t_annotations* > ()->last_lineno = driver.scanner->get_lineno();
    }
#line 3113 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 154: // TypeAnnotations: "(" TypeAnnotationList CommaOrSemicolonOptional $@12 ")"
#line 1432 "parse/thrifty.yy"
    {
      driver.debug("TypeAnnotations => ( TypeAnnotationList CommaOrSemicolonOptional)");
      yylhs.value.as < t_annotations* > () = yystack_[3].value.as < t_annotations* > ();
    }
#line 3122 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 155: // TypeAnnotations: "(" ")"
#line 1437 "parse/thrifty.yy"
    {
      driver.debug("TypeAnnotations => ( )");
      yylhs.value.as < t_annotations* > () = nullptr;
    }
#line 3131 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 156: // TypeAnnotations: %empty
#line 1442 "parse/thrifty.yy"
    {
      driver.debug("TypeAnnotations =>");
      yylhs.value.as < t_annotations* > () = nullptr;
    }
#line 3140 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 157: // TypeAnnotationList: TypeAnnotationList CommaOrSemicolon TypeAnnotation
#line 1449 "parse/thrifty.yy"
    {
      driver.debug("TypeAnnotationList => TypeAnnotationList CommaOrSemicolon TypeAnnotation");
      yylhs.value.as < t_annotations* > () = yystack_[2].value.as < t_annotations* > ();
      yylhs.value.as < t_annotations* > ()->strings[yystack_[0].value.as < t_annotation* > ()->first] = std::move(yystack_[0].value.as < t_annotation* > ()->second);
      delete yystack_[0].value.as < t_annotation* > ();
    }
#line 3151 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 158: // TypeAnnotationList: TypeAnnotation
#line 1456 "parse/thrifty.yy"
    {
      driver.debug("TypeAnnotationList => TypeAnnotation");
      /* Just use a dummy structure to hold the annotations. */
      yylhs.value.as < t_annotations* > () = new t_annotations();
      yylhs.value.as < t_annotations* > ()->strings[yystack_[0].value.as < t_annotation* > ()->first] = std::move(yystack_[0].value.as < t_annotation* > ()->second);
      delete yystack_[0].value.as < t_annotation* > ();
    }
#line 3163 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 159: // TypeAnnotation: Identifier "=" IntOrLiteral
#line 1466 "parse/thrifty.yy"
    {
      driver.debug("TypeAnnotation -> Identifier = IntOrLiteral");
      yylhs.value.as < t_annotation* > () = new t_annotation{yystack_[2].value.as < std::string > (), yystack_[0].value.as < std::string > ()};
    }
#line 3172 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 160: // TypeAnnotation: Identifier
#line 1471 "parse/thrifty.yy"
    {
      driver.debug("TypeAnnotation -> Identifier");
      yylhs.value.as < t_annotation* > () = new t_annotation{yystack_[0].value.as < std::string > (), "1"};
    }
#line 3181 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 161: // StructuredAnnotations: NonEmptyStructuredAnnotationList
#line 1478 "parse/thrifty.yy"
    {
      driver.debug("StructuredAnnotations -> NonEmptyStructuredAnnotationList");
      yylhs.value.as < t_struct_annotations* > () = yystack_[0].value.as < t_struct_annotations* > ();
    }
#line 3190 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 162: // StructuredAnnotations: %empty
#line 1483 "parse/thrifty.yy"
    {
      driver.debug("StructuredAnnotations ->");
      yylhs.value.as < t_struct_annotations* > () = nullptr;
    }
#line 3199 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 163: // NonEmptyStructuredAnnotationList: NonEmptyStructuredAnnotationList StructuredAnnotation
#line 1490 "parse/thrifty.yy"
    {
      driver.debug("NonEmptyStructuredAnnotationList -> NonEmptyStructuredAnnotationList StructuredAnnotation");
      yylhs.value.as < t_struct_annotations* > () = yystack_[1].value.as < t_struct_annotations* > ();
      yylhs.value.as < t_struct_annotations* > ()->emplace_back(yystack_[0].value.as < t_const* > ());
    }
#line 3209 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 164: // NonEmptyStructuredAnnotationList: StructuredAnnotation
#line 1496 "parse/thrifty.yy"
    {
      driver.debug("NonEmptyStructuredAnnotationList ->");
      yylhs.value.as < t_struct_annotations* > () = new t_struct_annotations;
      yylhs.value.as < t_struct_annotations* > ()->emplace_back(yystack_[0].value.as < t_const* > ());
    }
#line 3219 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 165: // StructuredAnnotation: "@" ConstStruct
#line 1504 "parse/thrifty.yy"
    {
      driver.debug("StructuredAnnotation => @ConstStruct");
      yylhs.value.as < t_const* > () = driver.new_struct_annotation(own(yystack_[0].value.as < t_const_value* > ())).release();
    }
#line 3228 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 166: // StructuredAnnotation: "@" ConstStructType
#line 1509 "parse/thrifty.yy"
    {
      driver.debug("StructuredAnnotation => @ConstStructType");
      auto value = std::make_unique<t_const_value>();
      value->set_map();
      value->set_ttype(own(yystack_[0].value.as < t_type_ref* > ()));
      yylhs.value.as < t_const* > () = driver.new_struct_annotation(std::move(value)).release();
    }
#line 3240 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 167: // FunctionAnnotations: TypeAnnotations
#line 1519 "parse/thrifty.yy"
    {
      driver.debug("FunctionAnnotations => TypeAnnotations");
      if (!yystack_[0].value.as < t_annotations* > ()) {
        yylhs.value.as < t_annotations* > () = nullptr;
        break;
      }
      yylhs.value.as < t_annotations* > () = yystack_[0].value.as < t_annotations* > ();
      auto priority = yylhs.value.as < t_annotations* > ()->strings.find("priority");
      if (priority == yylhs.value.as < t_annotations* > ()->strings.end()) {
        break;
      }
      const std::string& prio = priority->second;
      const std::string prio_list[] = {"HIGH_IMPORTANT", "HIGH", "IMPORTANT",
                                       "NORMAL", "BEST_EFFORT"};
      const auto end = prio_list + sizeof(prio_list)/sizeof(prio_list[0]);
      if (std::find(prio_list, end, prio) == end) {
        std::string s;
        for (const auto& prio : prio_list) {
          s += prio + "','";
        }
        s.erase(s.length() - 3);
        driver.failure("Bad priority '%s'. Choose one of '%s'.",
                       prio.c_str(), s.c_str());
      }
    }
#line 3270 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 168: // IntOrLiteral: tok_literal
#line 1547 "parse/thrifty.yy"
    {
      driver.debug("IntOrLiteral -> tok_literal");
      yylhs.value.as < std::string > () = yystack_[0].value.as < std::string > ();
    }
#line 3279 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 169: // IntOrLiteral: tok_bool_constant
#line 1553 "parse/thrifty.yy"
    {
      char buf[21];  // max len of int64_t as string + null terminator
      driver.debug("IntOrLiteral -> tok_bool_constant");
      sprintf(buf, "%" PRIi64, yystack_[0].value.as < int64_t > ());
      yylhs.value.as < std::string > () = buf;
    }
#line 3290 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;

  case 170: // IntOrLiteral: tok_int_constant
#line 1561 "parse/thrifty.yy"
    {
      char buf[21];  // max len of int64_t as string + null terminator
      driver.debug("IntOrLiteral -> tok_int_constant");
      sprintf(buf, "%" PRIi64, yystack_[0].value.as < int64_t > ());
      yylhs.value.as < std::string > () = buf;
    }
#line 3301 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"
    break;


#line 3305 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"

            default:
              break;
            }
        }
#if YY_EXCEPTIONS
      catch (const syntax_error& yyexc)
        {
          YYCDEBUG << "Caught exception: " << yyexc.what() << '\n';
          error (yyexc);
          YYERROR;
        }
#endif // YY_EXCEPTIONS
      YY_SYMBOL_PRINT ("-> $$ =", yylhs);
      yypop_ (yylen);
      yylen = 0;

      // Shift the result of the reduction.
      yypush_ (YY_NULLPTR, YY_MOVE (yylhs));
    }
    goto yynewstate;


  /*--------------------------------------.
  | yyerrlab -- here on detecting error.  |
  `--------------------------------------*/
  yyerrlab:
    // If not already recovering from an error, report this error.
    if (!yyerrstatus_)
      {
        ++yynerrs_;
        std::string msg = YY_("syntax error");
        error (YY_MOVE (msg));
      }


    if (yyerrstatus_ == 3)
      {
        /* If just tried and failed to reuse lookahead token after an
           error, discard it.  */

        // Return failure if at end of input.
        if (yyla.kind () == symbol_kind::S_YYEOF)
          YYABORT;
        else if (!yyla.empty ())
          {
            yy_destroy_ ("Error: discarding", yyla);
            yyla.clear ();
          }
      }

    // Else will try to reuse lookahead token after shifting the error token.
    goto yyerrlab1;


  /*---------------------------------------------------.
  | yyerrorlab -- error raised explicitly by YYERROR.  |
  `---------------------------------------------------*/
  yyerrorlab:
    /* Pacify compilers when the user code never invokes YYERROR and
       the label yyerrorlab therefore never appears in user code.  */
    if (false)
      YYERROR;

    /* Do not reclaim the symbols of the rule whose action triggered
       this YYERROR.  */
    yypop_ (yylen);
    yylen = 0;
    YY_STACK_PRINT ();
    goto yyerrlab1;


  /*-------------------------------------------------------------.
  | yyerrlab1 -- common code for both syntax error and YYERROR.  |
  `-------------------------------------------------------------*/
  yyerrlab1:
    yyerrstatus_ = 3;   // Each real token shifted decrements this.
    // Pop stack until we find a state that shifts the error token.
    for (;;)
      {
        yyn = yypact_[+yystack_[0].state];
        if (!yy_pact_value_is_default_ (yyn))
          {
            yyn += symbol_kind::S_YYerror;
            if (0 <= yyn && yyn <= yylast_
                && yycheck_[yyn] == symbol_kind::S_YYerror)
              {
                yyn = yytable_[yyn];
                if (0 < yyn)
                  break;
              }
          }

        // Pop the current state because it cannot handle the error token.
        if (yystack_.size () == 1)
          YYABORT;

        yy_destroy_ ("Error: popping", yystack_[0]);
        yypop_ ();
        YY_STACK_PRINT ();
      }
    {
      stack_symbol_type error_token;


      // Shift the error token.
      error_token.state = state_type (yyn);
      yypush_ ("Shifting", YY_MOVE (error_token));
    }
    goto yynewstate;


  /*-------------------------------------.
  | yyacceptlab -- YYACCEPT comes here.  |
  `-------------------------------------*/
  yyacceptlab:
    yyresult = 0;
    goto yyreturn;


  /*-----------------------------------.
  | yyabortlab -- YYABORT comes here.  |
  `-----------------------------------*/
  yyabortlab:
    yyresult = 1;
    goto yyreturn;


  /*-----------------------------------------------------.
  | yyreturn -- parsing is finished, return the result.  |
  `-----------------------------------------------------*/
  yyreturn:
    if (!yyla.empty ())
      yy_destroy_ ("Cleanup: discarding lookahead", yyla);

    /* Do not reclaim the symbols of the rule whose action triggered
       this YYABORT or YYACCEPT.  */
    yypop_ (yylen);
    YY_STACK_PRINT ();
    while (1 < yystack_.size ())
      {
        yy_destroy_ ("Cleanup: popping", yystack_[0]);
        yypop_ ();
      }

    return yyresult;
  }
#if YY_EXCEPTIONS
    catch (...)
      {
        YYCDEBUG << "Exception caught: cleaning lookahead and stack\n";
        // Do not try to display the values of the reclaimed symbols,
        // as their printers might throw an exception.
        if (!yyla.empty ())
          yy_destroy_ (YY_NULLPTR, yyla);

        while (1 < yystack_.size ())
          {
            yy_destroy_ (YY_NULLPTR, yystack_[0]);
            yypop_ ();
          }
        throw;
      }
#endif // YY_EXCEPTIONS
  }

  void
  parser::error (const syntax_error& yyexc)
  {
    error (yyexc.what ());
  }

#if YYDEBUG || 0
  const char *
  parser::symbol_name (symbol_kind_type yysymbol)
  {
    return yytname_[yysymbol];
  }
#endif // #if YYDEBUG || 0





  const short parser::yypact_ninf_ = -247;

  const signed char parser::yytable_ninf_ = -91;

  const short
  parser::yypact_[] =
  {
    -247,    12,    25,  -247,    65,    15,    29,   364,    48,    53,
    -247,  -247,     1,    72,  -247,  -247,  -247,  -247,  -247,  -247,
    -247,  -247,  -247,  -247,  -247,  -247,  -247,  -247,  -247,  -247,
    -247,  -247,  -247,  -247,  -247,   295,  -247,  -247,   364,  -247,
       1,  -247,  -247,   275,   364,   364,   364,   275,   364,   364,
     -26,  -247,  -247,  -247,  -247,    50,  -247,  -247,  -247,  -247,
    -247,  -247,  -247,  -247,  -247,  -247,    46,    57,    61,    55,
     364,    55,    55,  -247,  -247,  -247,  -247,  -247,  -247,   364,
    -247,  -247,  -247,  -247,  -247,   -23,   343,   275,   275,   275,
     354,  -247,  -247,  -247,  -247,    58,    27,    80,  -247,    92,
      93,  -247,  -247,    59,  -247,    94,    19,    96,    99,   100,
    -247,   112,    19,  -247,    55,  -247,   364,   101,  -247,   113,
    -247,  -247,   364,   285,  -247,  -247,   364,   118,   275,  -247,
    -247,    10,   364,  -247,  -247,   123,  -247,  -247,   125,   285,
     126,  -247,  -247,  -247,  -247,  -247,  -247,    52,   194,   102,
    -247,  -247,  -247,  -247,    50,   128,  -247,   122,  -247,  -247,
    -247,  -247,  -247,   127,    55,   136,  -247,  -247,    55,   364,
    -247,    55,    55,    -9,   133,  -247,   130,    19,  -247,  -247,
      19,   285,  -247,  -247,  -247,   131,   -16,    -9,  -247,   138,
    -247,    19,  -247,   275,    -8,   137,  -247,  -247,   285,   285,
     141,   285,   139,  -247,  -247,  -247,  -247,   275,   143,   150,
      55,  -247,  -247,   148,  -247,  -247,  -247,   227,    55,   147,
    -247,   144,  -247,  -247,  -247,   364,    55,  -247,    19,  -247,
    -247,   146,   149,   364,  -247,  -247,  -247,  -247,   154,  -247,
      55,   285,  -247,  -247,  -247,  -247,   275,   275,  -247,    28,
    -247,  -247,   153,   -14,   158,   117,   155,   149,  -247,  -247,
     285,    55,  -247,   159,   151,   275,  -247,  -247,  -247,    19,
    -247,  -247,   160,   157,  -247,  -247,   161,  -247,   117,  -247,
    -247,  -247,  -247,    55,    19,  -247
  };

  const unsigned char
  parser::yydefact_[] =
  {
      17,     0,    26,     1,     0,    14,     0,     0,     0,     0,
      16,    18,   162,    79,    25,    28,    29,    27,    30,    31,
      32,    33,    34,    23,     3,     4,     5,     7,     6,     8,
       9,    10,    11,    12,    13,     0,    21,    22,     0,    24,
     161,   164,    78,     0,     0,     0,     0,     0,     0,     0,
      83,    20,    19,    69,   165,   166,   163,   140,   141,   138,
     139,   142,   143,   144,   145,   146,     0,     0,     0,   156,
       0,   156,   156,   147,   148,   149,    72,    87,    41,     0,
      74,    93,    80,    81,    82,    86,     0,     0,     0,     0,
       0,   135,    35,   136,   137,     0,    92,     0,    49,     0,
       0,    85,    84,     0,    68,     0,    40,     0,     0,     0,
     155,   160,    40,   158,   156,   112,     0,     0,    44,     0,
     112,    89,     0,     0,    37,    38,    39,     0,     0,   152,
     151,     0,    39,   153,    36,    14,    91,    89,    14,     0,
      14,    96,    76,    54,    51,    52,    53,     0,     0,    55,
      71,    56,    57,    58,     0,     0,    67,     0,   168,   169,
     170,   159,   157,     0,   156,   116,   111,    96,   156,     0,
      43,   156,   156,    14,     0,    64,     0,    40,    60,    62,
      40,     0,   150,   154,    73,     0,   119,    14,    42,    48,
      45,    40,    75,     0,   107,     0,    95,   112,     0,    39,
       0,    39,     0,    70,   115,   117,   118,     0,     0,     0,
     156,    39,    50,     0,   104,   105,   106,     0,   156,    14,
      66,     0,    63,    61,    59,     0,   156,    47,    40,    99,
     125,     0,     4,     0,   122,   127,   123,   131,   124,    94,
     156,     0,   113,   167,    88,    46,     0,     0,    97,     0,
      77,    65,   121,     0,     0,   133,     0,     0,   126,   130,
       0,   156,   128,     0,     0,     0,   134,   102,   120,    40,
     112,   129,     0,    14,   101,   114,    14,   132,   110,   100,
     103,   108,   109,   156,    40,    98
  };

  const short
  parser::yypgoto_[] =
  {
    -247,  -247,    -7,  -247,  -247,  -247,  -247,  -247,    -3,  -247,
    -247,  -247,  -247,   -93,  -106,  -247,  -247,  -247,  -247,  -247,
    -247,  -247,  -247,  -123,  -247,  -247,  -247,  -247,   145,   152,
    -247,  -247,  -247,  -247,  -247,  -247,  -247,  -247,  -247,  -247,
    -247,  -247,    45,    -2,  -247,  -247,  -247,    20,  -247,  -247,
    -247,  -247,  -247,  -247,  -246,  -247,  -117,   -87,  -247,  -247,
    -247,  -247,  -247,  -247,   -60,  -247,   -56,   -77,   -42,  -247,
    -247,  -247,  -247,  -247,   -61,  -247,  -247,    63,  -247,  -247,
     156,   -84,  -247
  };

  const short
  parser::yydefgoto_[] =
  {
      -1,     1,    69,    12,     4,     2,    10,    11,   165,     5,
      14,    15,   114,   211,   127,    16,    97,   138,   170,   210,
     190,    17,   119,   150,   151,   180,   152,   177,   153,   154,
     106,    18,    95,    19,    99,    20,   174,    50,    85,   103,
      21,    96,   141,   195,   117,    22,   100,   173,   196,   256,
     273,   274,   279,   217,   264,   283,   135,   166,   252,   186,
     207,   261,   233,   234,   235,   236,   237,   254,   255,    71,
      72,    73,    74,    75,   243,   163,   112,   113,    39,    40,
      41,   244,   161
  };

  const short
  parser::yytable_[] =
  {
      35,    70,    13,   140,   -90,    79,   133,   262,    91,   266,
      93,    94,     3,   126,   158,    -2,   171,   159,   160,   132,
      82,    83,    84,    38,   176,   179,   101,   102,    52,   124,
     125,    53,   282,    23,   214,   215,   216,    76,    77,    78,
     263,    80,    81,   205,   206,   107,   108,   109,   -15,   -15,
     -15,   -15,    36,   134,   193,    24,   143,    37,   203,   144,
     145,   146,    86,    92,   147,   175,    87,   148,   231,   257,
     115,   200,    98,    90,   202,   220,   221,    88,   223,   105,
     219,    89,   116,   111,   199,   212,   157,   201,     6,     7,
       8,     9,   118,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,   184,   120,   121,   128,   188,   123,   136,
     191,   192,   122,   137,   -69,   142,   149,    42,   251,   155,
     129,   130,   245,    43,    44,   111,   131,   139,    45,    46,
      47,   156,   149,    48,    49,   169,   164,   268,   168,   172,
     149,   149,   181,   182,   185,   197,   183,   198,   204,   228,
     218,   213,   209,   276,   222,   224,   226,   239,   227,   229,
     240,   241,   189,   275,   249,   225,   246,   260,   265,   247,
     194,   263,   271,   267,   149,   238,   278,   270,   285,   250,
     281,   277,   167,    54,   194,   208,   280,   187,   272,   258,
      55,   149,   149,   259,   149,   162,    56,    24,   143,   284,
     269,   144,   145,   146,   253,     0,   147,     0,     0,   148,
     178,     0,     0,     0,     0,     0,     0,     0,   242,     0,
       0,     0,     0,     0,     0,     0,   248,     0,     0,     0,
      24,     0,     0,     0,   149,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,     0,     0,     0,     0,     0,
       0,     0,     0,   149,   230,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,   231,   232,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    24,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    24,   143,
       0,     0,   144,   145,   146,     0,     0,   147,    24,    51,
     148,     0,     0,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,     0,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    24,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   104,    24,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    24,     0,     0,
       0,     0,     0,   110,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,     0,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34
  };

  const short
  parser::yycheck_[] =
  {
       7,    43,     5,   120,    13,    47,   112,    21,    69,   255,
      71,    72,     0,   106,     4,     0,   139,     7,     8,   112,
      46,    47,    48,    22,   147,   148,    49,    50,    35,    10,
      11,    38,   278,     4,    42,    43,    44,    44,    45,    46,
      54,    48,    49,    59,    60,    87,    88,    89,    23,    24,
      25,    26,     4,   114,    63,     3,     4,     4,   181,     7,
       8,     9,    12,    70,    12,    13,    20,    15,    40,    41,
      12,   177,    79,    18,   180,   198,   199,    20,   201,    86,
     197,    20,    55,    90,   177,   191,   128,   180,    23,    24,
      25,    26,    12,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,   164,    12,    12,    10,   168,    14,   116,
     171,   172,    53,    12,    12,   122,   123,    45,   241,   126,
      21,    21,   228,    51,    52,   132,    14,    14,    56,    57,
      58,    13,   139,    61,    62,   138,    13,   260,    13,    13,
     147,   148,    14,    21,     8,    12,    19,    17,    17,   210,
      13,   193,    14,   270,    13,    16,    13,   218,     8,    11,
      13,    17,   169,   269,    10,   207,    20,    14,    10,    20,
     173,    54,    21,    18,   181,   217,    19,    18,   284,   240,
      19,    21,   137,    38,   187,   187,   273,   167,   265,   249,
      38,   198,   199,   249,   201,   132,    40,     3,     4,   283,
     261,     7,     8,     9,   246,    -1,    12,    -1,    -1,    15,
      16,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   225,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   233,    -1,    -1,    -1,
       3,    -1,    -1,    -1,   241,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   260,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     3,     4,
      -1,    -1,     7,     8,     9,    -1,    -1,    12,     3,     4,
      15,    -1,    -1,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    -1,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,     3,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    13,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,     3,    -1,    -1,
      -1,    -1,    -1,    19,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    -1,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50
  };

  const unsigned char
  parser::yystos_[] =
  {
       0,    65,    69,     0,    68,    73,    23,    24,    25,    26,
      70,    71,    67,    72,    74,    75,    79,    85,    95,    97,
      99,   104,   109,     4,     3,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    66,     4,     4,    22,   142,
     143,   144,    45,    51,    52,    56,    57,    58,    61,    62,
     101,     4,    66,    66,    92,    93,   144,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    66,
     132,   133,   134,   135,   136,   137,    66,    66,    66,   132,
      66,    66,    46,    47,    48,   102,    12,    20,    20,    20,
      18,   138,    66,   138,   138,    96,   105,    80,    66,    98,
     110,    49,    50,   103,    13,    66,    94,   132,   132,   132,
      19,    66,   140,   141,    76,    12,    55,   108,    12,    86,
      12,    12,    53,    14,    10,    11,    77,    78,    10,    21,
      21,    14,    77,    78,   138,   120,    66,    12,    81,    14,
     120,   106,    66,     4,     7,     8,     9,    12,    15,    66,
      87,    88,    90,    92,    93,    66,    13,   132,     4,     7,
       8,   146,   141,   139,    13,    72,   121,   106,    13,    72,
      82,    87,    13,   111,   100,    13,    87,    91,    16,    87,
      89,    14,    21,    19,   138,     8,   123,   111,   138,    66,
      84,   138,   138,    63,    72,   107,   112,    12,    17,    77,
      78,    77,    78,    87,    17,    59,    60,   124,   107,    14,
      83,    77,    78,   132,    42,    43,    44,   117,    13,   120,
      87,    87,    13,    87,    16,   132,    13,     8,   138,    11,
      27,    40,    41,   126,   127,   128,   129,   130,   132,   138,
      13,    17,    66,   138,   145,    78,    20,    20,    66,    10,
     138,    87,   122,   132,   131,   132,   113,    41,   128,   130,
      14,   125,    21,    54,   118,    10,   118,    18,    87,   138,
      18,    21,   131,   114,   115,    78,   120,    21,    19,   116,
     121,    19,   118,   119,   145,    78
  };

  const unsigned char
  parser::yyr1_[] =
  {
       0,    64,    65,    66,    66,    66,    66,    66,    66,    66,
      66,    66,    66,    66,    67,    68,    69,    69,    70,    70,
      70,    70,    70,    71,    72,    73,    73,    74,    74,    74,
      74,    74,    74,    74,    74,    76,    75,    77,    77,    78,
      78,    80,    79,    81,    81,    83,    82,    84,    84,    86,
      85,    87,    87,    87,    87,    87,    87,    87,    87,    88,
      88,    89,    89,    90,    90,    91,    91,    92,    92,    93,
      94,    94,    96,    95,    98,    97,   100,    99,   101,   101,
     102,   102,   102,   102,   103,   103,   103,   105,   104,   106,
     107,   108,   108,   110,   109,   111,   111,   113,   112,   112,
     114,   114,   115,   116,   117,   117,   117,   117,   118,   119,
     119,   120,   120,   122,   121,   123,   123,   124,   124,   124,
     125,   125,   126,   126,   126,   126,   127,   127,   128,   128,
     129,   129,   130,   131,   131,   132,   132,   132,   133,   133,
     133,   133,   133,   133,   133,   133,   133,   134,   134,   134,
     135,   136,   137,   139,   138,   138,   138,   140,   140,   141,
     141,   142,   142,   143,   143,   144,   144,   145,   146,   146,
     146
  };

  const signed char
  parser::yyr2_[] =
  {
       0,     2,     2,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     0,     0,     3,     0,     1,     3,
       3,     2,     2,     2,     2,     2,     0,     1,     1,     1,
       1,     1,     1,     1,     1,     0,     6,     1,     1,     1,
       0,     0,     8,     2,     0,     0,     5,     3,     1,     0,
       9,     1,     1,     1,     1,     1,     1,     1,     1,     4,
       2,     3,     1,     4,     2,     5,     3,     5,     3,     1,
       5,     3,     0,     8,     0,     8,     0,    11,     1,     0,
       1,     1,     1,     0,     1,     1,     0,     0,    11,     0,
       0,     2,     0,     0,    10,     2,     0,     0,    11,     3,
       2,     1,     0,     1,     1,     1,     1,     0,     4,     1,
       0,     2,     0,     0,     9,     2,     0,     1,     1,     0,
       2,     0,     1,     1,     1,     1,     3,     1,     4,     5,
       3,     1,     6,     1,     2,     2,     2,     2,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       6,     4,     4,     0,     5,     2,     0,     3,     1,     3,
       1,     1,     0,     2,     1,     2,     2,     1,     1,     1,
       1
  };


#if YYDEBUG
  // YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
  // First, the terminals, then, starting at \a YYNTOKENS, nonterminals.
  const char*
  const parser::yytname_[] =
  {
  "tok_eof", "error", "\"invalid token\"", "tok_identifier",
  "tok_literal", "tok_doctext", "tok_st_identifier", "tok_bool_constant",
  "tok_int_constant", "tok_dub_constant", "\",\"", "\";\"", "\"{\"",
  "\"}\"", "\"=\"", "\"[\"", "\"]\"", "\":\"", "\"(\"", "\")\"", "\"<\"",
  "\">\"", "\"@\"", "tok_include", "tok_namespace", "tok_cpp_include",
  "tok_hs_include", "tok_void", "tok_bool", "tok_byte", "tok_string",
  "tok_binary", "tok_i16", "tok_i32", "tok_i64", "tok_double", "tok_float",
  "tok_map", "tok_list", "tok_set", "tok_stream", "tok_sink", "tok_oneway",
  "tok_idempotent", "tok_readonly", "tok_safe", "tok_transient",
  "tok_stateful", "tok_permanent", "tok_server", "tok_client",
  "tok_typedef", "tok_struct", "tok_exception", "tok_throws",
  "tok_extends", "tok_service", "tok_enum", "tok_const", "tok_required",
  "tok_optional", "tok_union", "tok_interaction", "tok_performs",
  "$accept", "Program", "Identifier", "CaptureDocText", "DestroyDocText",
  "HeaderList", "Header", "Include", "DefinitionAttrs", "DefinitionList",
  "Definition", "Typedef", "$@1", "CommaOrSemicolon",
  "CommaOrSemicolonOptional", "Enum", "$@2", "EnumDefList", "EnumDef",
  "$@3", "EnumValue", "Const", "$@4", "ConstValue", "ConstList",
  "ConstListContents", "ConstMap", "ConstMapContents", "ConstStruct",
  "ConstStructType", "ConstStructContents", "Struct", "$@5", "Union",
  "$@6", "Exception", "$@7", "ErrorSafety", "ErrorKind", "ErrorBlame",
  "Service", "$@8", "FlagArgs", "UnflagArgs", "Extends", "Interaction",
  "$@9", "FunctionList", "Function", "$@10", "ParamList", "EmptyParamList",
  "Param", "FunctionQualifier", "Throws", "MaybeThrows", "FieldList",
  "Field", "$@11", "FieldIdentifier", "FieldRequiredness", "FieldValue",
  "FunctionType", "ResponseAndStreamReturnType", "StreamReturnType",
  "ResponseAndSinkReturnType", "SinkReturnType", "SinkFieldType",
  "FieldType", "BaseType", "ContainerType", "MapType", "SetType",
  "ListType", "TypeAnnotations", "$@12", "TypeAnnotationList",
  "TypeAnnotation", "StructuredAnnotations",
  "NonEmptyStructuredAnnotationList", "StructuredAnnotation",
  "FunctionAnnotations", "IntOrLiteral", YY_NULLPTR
  };
#endif


#if YYDEBUG
  const short
  parser::yyrline_[] =
  {
       0,   313,   313,   326,   331,   335,   339,   343,   347,   351,
     355,   359,   363,   367,   374,   385,   394,   399,   404,   408,
     415,   422,   429,   436,   456,   467,   472,   477,   482,   487,
     492,   497,   502,   507,   512,   520,   519,   532,   534,   538,
     543,   549,   548,   561,   568,   575,   574,   587,   607,   617,
     616,   637,   643,   654,   660,   665,   693,   698,   703,   710,
     715,   723,   729,   738,   744,   752,   758,   767,   773,   782,
     789,   795,   805,   804,   819,   818,   834,   833,   879,   885,
     890,   896,   902,   908,   913,   919,   925,   932,   931,   945,
     950,   955,   970,   976,   975,  1004,  1011,  1018,  1017,  1038,
    1055,  1065,  1071,  1077,  1084,  1088,  1093,  1099,  1104,  1110,
    1114,  1119,  1126,  1133,  1132,  1162,  1198,  1204,  1215,  1227,
    1232,  1242,  1247,  1252,  1257,  1262,  1269,  1275,  1282,  1287,
    1294,  1300,  1307,  1315,  1319,  1325,  1330,  1335,  1342,  1347,
    1352,  1357,  1362,  1367,  1372,  1377,  1382,  1389,  1394,  1399,
    1406,  1413,  1420,  1428,  1427,  1436,  1442,  1448,  1455,  1465,
    1470,  1477,  1483,  1489,  1495,  1503,  1508,  1518,  1546,  1552,
    1560
  };

  void
  parser::yy_stack_print_ () const
  {
    *yycdebug_ << "Stack now";
    for (stack_type::const_iterator
           i = yystack_.begin (),
           i_end = yystack_.end ();
         i != i_end; ++i)
      *yycdebug_ << ' ' << int (i->state);
    *yycdebug_ << '\n';
  }

  void
  parser::yy_reduce_print_ (int yyrule) const
  {
    int yylno = yyrline_[yyrule];
    int yynrhs = yyr2_[yyrule];
    // Print the symbols being reduced, and their result.
    *yycdebug_ << "Reducing stack by rule " << yyrule - 1
               << " (line " << yylno << "):\n";
    // The symbols being reduced.
    for (int yyi = 0; yyi < yynrhs; yyi++)
      YY_SYMBOL_PRINT ("   $" << yyi + 1 << " =",
                       yystack_[(yynrhs) - (yyi + 1)]);
  }
#endif // YYDEBUG


#line 112 "parse/thrifty.yy"
} } } } // apache::thrift::compiler::yy
#line 3861 "/builddir/build/BUILD/fbthrift-2021.04.26.00/aarch64-redhat-linux-gnu/thrift/compiler/thrifty.cc"

#line 1568 "parse/thrifty.yy"


/**
 * Method that will be called by the generated parser upon errors.
 */
void apache::thrift::compiler::yy::parser::error(std::string const& message) {
  driver.yyerror("%s", message.c_str());
}
